"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CmptAction = void 0;
var tslib_1 = require("tslib");
var Action_1 = require("./Action");
/**
 * 组件动作
 *
 * @export
 * @class CmptAction
 * @implements {Action}
 */
var CmptAction = /** @class */ (function () {
    function CmptAction() {
    }
    CmptAction.prototype.run = function (action, renderer, event) {
        var _a, _b, _c;
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var component;
            return (0, tslib_1.__generator)(this, function (_d) {
                // 显隐&状态控制
                if (['show', 'hidden'].includes(action.actionType)) {
                    return [2 /*return*/, renderer.props.rootStore.setVisible(action.componentId, action.actionType === 'show')];
                }
                else if (['enabled', 'disabled'].includes(action.actionType)) {
                    return [2 /*return*/, renderer.props.rootStore.setDisable(action.componentId, action.actionType === 'disabled')];
                }
                component = action.componentId && renderer.props.$schema.id !== action.componentId
                    ? (_a = event.context.scoped) === null || _a === void 0 ? void 0 : _a.getComponentById(action.componentId)
                    : renderer;
                // 刷新
                if (action.actionType === 'reload') {
                    return [2 /*return*/, (_b = component.reload) === null || _b === void 0 ? void 0 : _b.call(component, undefined, action.args)];
                }
                // 执行组件动作
                return [2 /*return*/, (_c = component.doAction) === null || _c === void 0 ? void 0 : _c.call(component, action, action.args)];
            });
        });
    };
    return CmptAction;
}());
exports.CmptAction = CmptAction;
(0, Action_1.registerAction)('component', new CmptAction());
//# sourceMappingURL=./actions/CmptAction.js.map
