import { RendererEvent } from '../utils/renderer-event';
import { Action, ListenerAction, ListenerContext } from './Action';
/**
 * 打开弹窗动作
 *
 * @export
 * @class DialogAction
 * @implements {Action}
 */
export declare class DialogAction implements Action {
    run(action: ListenerAction, renderer: ListenerContext, event: RendererEvent<any>): Promise<void>;
}
/**
 * 关闭弹窗动作
 *
 * @export
 * @class CloseDialogAction
 * @implements {Action}
 */
export declare class CloseDialogAction implements Action {
    run(action: ListenerAction, renderer: ListenerContext, event: RendererEvent<any>): Promise<void>;
}
/**
 * alert提示动作
 */
export declare class AlertAction implements Action {
    run(action: ListenerAction, renderer: ListenerContext, event: RendererEvent<any>): Promise<void>;
}
/**
 * confirm确认提示动作
 */
export declare class ConfirmAction implements Action {
    run(action: ListenerAction, renderer: ListenerContext, event: RendererEvent<any>): Promise<void>;
}
