/// <reference types="react" />
import { OptionsControlProps } from './Options';
import { BaseTransferRenderer, TransferControlSchema } from './Transfer';
import { ItemRenderStates } from '../../components/Selection';
/**
 * TabsTransfer
 * 文档：https://baidu.gitee.io/amis/docs/components/form/tabs-transfer
 */
export interface TabsTransferControlSchema extends Omit<TransferControlSchema, 'type'> {
    type: 'tabs-transfer';
}
export interface TabsTransferProps extends OptionsControlProps, Omit<TabsTransferControlSchema, 'type' | 'options' | 'inputClassName' | 'className' | 'descriptionClassName'> {
}
export declare class TabsTransferRenderer extends BaseTransferRenderer<TabsTransferProps> {
    optionItemRender(option: any, states: ItemRenderStates): JSX.Element;
    render(): JSX.Element;
}
