/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.31.1(5a1b4999493d49c857497ad481d73a737439f305)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var j=["require","exports","vs/base/common/platform","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/uint","vs/base/common/uri","vs/editor/common/core/characterClassifier","vs/base/common/arrays","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/objects","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/modes/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],G=function(F){for(var n=[],M=0,R=F.length;M<R;M++)n[M]=j[F[M]];return n},ge=this,me=typeof global=="object"?global:{},X;(function(F){F.global=ge;var n=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof F.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();F.Environment=n})(X||(X={}));var X;(function(F){var n=function(){function E(a,L,v){this.type=a,this.detail=L,this.timestamp=v}return E}();F.LoaderEvent=n;var M=function(){function E(a){this._events=[new n(1,"",a)]}return E.prototype.record=function(a,L){this._events.push(new n(a,L,F.Utilities.getHighPerformanceTimestamp()))},E.prototype.getEvents=function(){return this._events},E}();F.LoaderEventRecorder=M;var R=function(){function E(){}return E.prototype.record=function(a,L){},E.prototype.getEvents=function(){return[]},E.INSTANCE=new E,E}();F.NullLoaderEventRecorder=R})(X||(X={}));var X;(function(F){var n=function(){function M(){}return M.fileUriToFilePath=function(R,E){if(E=decodeURI(E).replace(/%23/g,"#"),R){if(/^file:\/\/\//.test(E))return E.substr(8);if(/^file:\/\//.test(E))return E.substr(5)}else if(/^file:\/\//.test(E))return E.substr(7);return E},M.startsWith=function(R,E){return R.length>=E.length&&R.substr(0,E.length)===E},M.endsWith=function(R,E){return R.length>=E.length&&R.substr(R.length-E.length)===E},M.containsQueryString=function(R){return/^[^\#]*\?/gi.test(R)},M.isAbsolutePath=function(R){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(R)},M.forEachProperty=function(R,E){if(R){var a=void 0;for(a in R)R.hasOwnProperty(a)&&E(a,R[a])}},M.isEmpty=function(R){var E=!0;return M.forEachProperty(R,function(){E=!1}),E},M.recursiveClone=function(R){if(!R||typeof R!="object"||R instanceof RegExp||!Array.isArray(R)&&Object.getPrototypeOf(R)!==Object.prototype)return R;var E=Array.isArray(R)?[]:{};return M.forEachProperty(R,function(a,L){L&&typeof L=="object"?E[a]=M.recursiveClone(L):E[a]=L}),E},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(R){return M.startsWith(R,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=F.global.performance&&typeof F.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?F.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();F.Utilities=n})(X||(X={}));var X;(function(F){function n(E){if(E instanceof Error)return E;var a=new Error(E.message||String(E)||"Unknown Error");return E.stack&&(a.stack=E.stack),a}F.ensureError=n;var M=function(){function E(){}return E.validateConfigurationOptions=function(a){function L(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError=="undefined"&&(a.catchError=!1),typeof a.recordStats=="undefined"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=L),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(F.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags=="undefined"&&(a.preferScriptTags=!1),Array.isArray(a.nodeModules)||(a.nodeModules=[]),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){var v=n(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",a.onError(v),a.nodeCachedData=void 0}return a},E.mergeConfigurationOptions=function(a,L){a===void 0&&(a=null),L===void 0&&(L=null);var v=F.Utilities.recursiveClone(L||{});return F.Utilities.forEachProperty(a,function(u,g){u==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules!="undefined"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(g):u==="paths"&&typeof v.paths!="undefined"?F.Utilities.forEachProperty(g,function(C,e){return v.paths[C]=e}):u==="config"&&typeof v.config!="undefined"?F.Utilities.forEachProperty(g,function(C,e){return v.config[C]=e}):v[u]=F.Utilities.recursiveClone(g)}),E.validateConfigurationOptions(v)},E}();F.ConfigurationOptionsUtil=M;var R=function(){function E(a,L){if(this._env=a,this.options=M.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var v=this.options.nodeRequire.main.filename,u=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var v=this.options.nodeMain,u=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,u+1)}}}return E.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0},E.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var a=0,L=this.options.nodeModules;a<L.length;a++){var v=L[a];this.nodeModulesMap[v]=!0}},E.prototype._createSortedPathsRules=function(){var a=this;this.sortedPathsRules=[],F.Utilities.forEachProperty(this.options.paths,function(L,v){Array.isArray(v)?a.sortedPathsRules.push({from:L,to:v}):a.sortedPathsRules.push({from:L,to:[v]})}),this.sortedPathsRules.sort(function(L,v){return v.from.length-L.from.length})},E.prototype.cloneAndMerge=function(a){return new E(this._env,M.mergeConfigurationOptions(a,this.options))},E.prototype.getOptionsLiteral=function(){return this.options},E.prototype._applyPaths=function(a){for(var L,v=0,u=this.sortedPathsRules.length;v<u;v++)if(L=this.sortedPathsRules[v],F.Utilities.startsWith(a,L.from)){for(var g=[],C=0,e=L.to.length;C<e;C++)g.push(L.to[C]+a.substr(L.from.length));return g}return[a]},E.prototype._addUrlArgsToUrl=function(a){return F.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs},E.prototype._addUrlArgsIfNecessaryToUrl=function(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a},E.prototype._addUrlArgsIfNecessaryToUrls=function(a){if(this.options.urlArgs)for(var L=0,v=a.length;L<v;L++)a[L]=this._addUrlArgsToUrl(a[L]);return a},E.prototype.moduleIdToPaths=function(a){if(this._env.isNode){var L=this.nodeModulesMap[a]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a);if(L)return this.isBuild()?["empty:"]:["node|"+a]}var v=a,u;if(!F.Utilities.endsWith(v,".js")&&!F.Utilities.isAbsolutePath(v)){u=this._applyPaths(v);for(var g=0,C=u.length;g<C;g++)this.isBuild()&&u[g]==="empty:"||(F.Utilities.isAbsolutePath(u[g])||(u[g]=this.options.baseUrl+u[g]),!F.Utilities.endsWith(u[g],".js")&&!F.Utilities.containsQueryString(u[g])&&(u[g]=u[g]+".js"))}else!F.Utilities.endsWith(v,".js")&&!F.Utilities.containsQueryString(v)&&(v=v+".js"),u=[v];return this._addUrlArgsIfNecessaryToUrls(u)},E.prototype.requireToUrl=function(a){var L=a;return F.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],F.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)},E.prototype.isBuild=function(){return this.options.isBuild},E.prototype.isDuplicateMessageIgnoredFor=function(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)},E.prototype.getConfigForModule=function(a){if(this.options.config)return this.options.config[a]},E.prototype.shouldCatchError=function(){return this.options.catchError},E.prototype.shouldRecordStats=function(){return this.options.recordStats},E.prototype.onError=function(a){this.options.onError(a)},E}();F.Configuration=R})(X||(X={}));var X;(function(F){var n=function(){function u(g){this._env=g,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(g,C,e,o){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new E;else if(this._env.isElectronRenderer){var b=g.getConfig().getOptionsLiteral().preferScriptTags;b?this._scriptLoader=new M:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new M;var N={callback:e,errorback:o};if(this._callbackMap.hasOwnProperty(C)){this._callbackMap[C].push(N);return}this._callbackMap[C]=[N],this._scriptLoader.load(g,C,function(){return h.triggerCallback(C)},function(m){return h.triggerErrorback(C,m)})},u.prototype.triggerCallback=function(g){var C=this._callbackMap[g];delete this._callbackMap[g];for(var e=0;e<C.length;e++)C[e].callback()},u.prototype.triggerErrorback=function(g,C){var e=this._callbackMap[g];delete this._callbackMap[g];for(var o=0;o<e.length;o++)e[o].errorback(C)},u}(),M=function(){function u(){}return u.prototype.attachListeners=function(g,C,e){var o=function(){g.removeEventListener("load",h),g.removeEventListener("error",b)},h=function(N){o(),C()},b=function(N){o(),e(N)};g.addEventListener("load",h),g.addEventListener("error",b)},u.prototype.load=function(g,C,e,o){if(/^node\|/.test(C)){var h=g.getConfig().getOptionsLiteral(),b=L(g.getRecorder(),h.nodeRequire||F.global.nodeRequire),N=C.split("|"),m=null;try{m=b(N[1])}catch(i){o(i);return}g.enqueueDefineAnonymousModule([],function(){return m}),e()}else{var w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript"),this.attachListeners(w,e,o);var p=g.getConfig().getOptionsLiteral().trustedTypesPolicy;p&&(C=p.createScriptURL(C)),w.setAttribute("src",C);var r=g.getConfig().getOptionsLiteral().cspNonce;r&&w.setAttribute("nonce",r),document.getElementsByTagName("head")[0].appendChild(w)}},u}();function R(u){var g=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var C=g?self.eval(g.createScript("","true")):new Function("true");return C.call(self),!0}catch(e){return!1}}var E=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(g){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=R(g)),this._cachedCanUseEval},u.prototype.load=function(g,C,e,o){if(/^node\|/.test(C)){var h=g.getConfig().getOptionsLiteral(),b=L(g.getRecorder(),h.nodeRequire||F.global.nodeRequire),N=C.split("|"),m=null;try{m=b(N[1])}catch(r){o(r);return}g.enqueueDefineAnonymousModule([],function(){return m}),e()}else{var w=g.getConfig().getOptionsLiteral().trustedTypesPolicy,p=/^((http:)|(https:)|(file:))/.test(C)&&C.substring(0,self.origin.length)!==self.origin;if(!p&&this._canUseEval(g)){fetch(C).then(function(r){if(r.status!==200)throw new Error(r.statusText);return r.text()}).then(function(r){r=r+`
//# sourceURL=`+C;var i=w?self.eval(w.createScript("",r)):new Function(r);i.call(self),e()}).then(void 0,o);return}try{w&&(C=w.createScriptURL(C)),importScripts(C),e()}catch(r){o(r)}}},u}(),a=function(){function u(g){this._env=g,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(g){this._didInitialize||(this._didInitialize=!0,this._fs=g("fs"),this._vm=g("vm"),this._path=g("path"),this._crypto=g("crypto"))},u.prototype._initNodeRequire=function(g,C){var e=C.getConfig().getOptionsLiteral().nodeCachedData;if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var o=this,h=g("module");function b(N){var m=N.constructor,w=function(r){try{return N.require(r)}finally{}};return w.resolve=function(r,i){return m._resolveFilename(r,N,!1,i)},w.resolve.paths=function(r){return m._resolveLookupPaths(r,N)},w.main=process.mainModule,w.extensions=m._extensions,w.cache=m._cache,w}h.prototype._compile=function(N,m){var w=h.wrap(N.replace(/^#!.*/,"")),p=C.getRecorder(),r=o._getCachedDataPath(e,m),i={filename:m},s;try{var f=o._fs.readFileSync(r);s=f.slice(0,16),i.cachedData=f.slice(16),p.record(60,r)}catch(y){p.record(61,r)}var d=new o._vm.Script(w,i),l=d.runInThisContext(i),_=o._path.dirname(m),c=b(this),S=[this.exports,c,this,m,_,process,me,Buffer],A=l.apply(this.exports,S);return o._handleCachedData(d,w,r,!i.cachedData,C),o._verifyCachedData(d,w,r,s,C),A}},u.prototype.load=function(g,C,e,o){var h=this,b=g.getConfig().getOptionsLiteral(),N=L(g.getRecorder(),b.nodeRequire||F.global.nodeRequire),m=b.nodeInstrumenter||function(l){return l};this._init(N),this._initNodeRequire(N,g);var w=g.getRecorder();if(/^node\|/.test(C)){var p=C.split("|"),r=null;try{r=N(p[1])}catch(l){o(l);return}g.enqueueDefineAnonymousModule([],function(){return r}),e()}else{C=F.Utilities.fileUriToFilePath(this._env.isWindows,C);var i=this._path.normalize(C),s=this._getElectronRendererScriptPathOrUri(i),f=Boolean(b.nodeCachedData),d=f?this._getCachedDataPath(b.nodeCachedData,C):void 0;this._readSourceAndCachedData(i,d,w,function(l,_,c,S){if(l){o(l);return}var A;_.charCodeAt(0)===u._BOM?A=u._PREFIX+_.substring(1)+u._SUFFIX:A=u._PREFIX+_+u._SUFFIX,A=m(A,i);var y={filename:s,cachedData:c},P=h._createAndEvalScript(g,A,y,e,o);h._handleCachedData(P,A,d,f&&!c,g),h._verifyCachedData(P,A,d,S,g)})}},u.prototype._createAndEvalScript=function(g,C,e,o,h){var b=g.getRecorder();b.record(31,e.filename);var N=new this._vm.Script(C,e),m=N.runInThisContext(e),w=g.getGlobalAMDDefineFunc(),p=!1,r=function(){return p=!0,w.apply(null,arguments)};return r.amd=w.amd,m.call(F.global,g.getGlobalAMDRequireFunc(),r,e.filename,this._path.dirname(e.filename)),b.record(32,e.filename),p?o():h(new Error("Didn't receive define call in "+e.filename+"!")),N},u.prototype._getElectronRendererScriptPathOrUri=function(g){if(!this._env.isElectronRenderer)return g;var C=g.match(/^([a-z])\:(.*)/i);return C?"file:///"+(C[1].toUpperCase()+":"+C[2]).replace(/\\/g,"/"):"file://"+g},u.prototype._getCachedDataPath=function(g,C){var e=this._crypto.createHash("md5").update(C,"utf8").update(g.seed,"utf8").update(process.arch,"").digest("hex"),o=this._path.basename(C).replace(/\.js$/,"");return this._path.join(g.path,o+"-"+e+".code")},u.prototype._handleCachedData=function(g,C,e,o,h){var b=this;g.cachedDataRejected?this._fs.unlink(e,function(N){h.getRecorder().record(62,e),b._createAndWriteCachedData(g,C,e,h),N&&h.getConfig().onError(N)}):o&&this._createAndWriteCachedData(g,C,e,h)},u.prototype._createAndWriteCachedData=function(g,C,e,o){var h=this,b=Math.ceil(o.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),N=-1,m=0,w=void 0,p=function(){setTimeout(function(){w||(w=h._crypto.createHash("md5").update(C,"utf8").digest());var r=g.createCachedData();if(!(r.length===0||r.length===N||m>=5)){if(r.length<N){p();return}N=r.length,h._fs.writeFile(e,Buffer.concat([w,r]),function(i){i&&o.getConfig().onError(i),o.getRecorder().record(63,e),p()})}},b*Math.pow(4,m++))};p()},u.prototype._readSourceAndCachedData=function(g,C,e,o){if(!C)this._fs.readFile(g,{encoding:"utf8"},o);else{var h=void 0,b=void 0,N=void 0,m=2,w=function(p){p?o(p):--m==0&&o(void 0,h,b,N)};this._fs.readFile(g,{encoding:"utf8"},function(p,r){h=r,w(p)}),this._fs.readFile(C,function(p,r){!p&&r&&r.length>0?(N=r.slice(0,16),b=r.slice(16),e.record(60,C)):e.record(61,C),w()})}},u.prototype._verifyCachedData=function(g,C,e,o,h){var b=this;!o||g.cachedDataRejected||setTimeout(function(){var N=b._crypto.createHash("md5").update(C,"utf8").digest();o.equals(N)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+e+"' now, but a RESTART IS REQUIRED")),b._fs.unlink(e,function(m){m&&h.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function L(u,g){if(g.__$__isRecorded)return g;var C=function(o){u.record(33,o);try{return g(o)}finally{u.record(34,o)}};return C.__$__isRecorded=!0,C}F.ensureRecordedNodeRequire=L;function v(u){return new n(u)}F.createScriptLoader=v})(X||(X={}));var X;(function(F){var n=function(){function v(u){var g=u.lastIndexOf("/");g!==-1?this.fromModulePath=u.substr(0,g+1):this.fromModulePath=""}return v._normalizeModuleId=function(u){var g=u,C;for(C=/\/\.\//;C.test(g);)g=g.replace(C,"/");for(g=g.replace(/^\.\//g,""),C=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;C.test(g);)g=g.replace(C,"/");return g=g.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),g},v.prototype.resolveModule=function(u){var g=u;return F.Utilities.isAbsolutePath(g)||(F.Utilities.startsWith(g,"./")||F.Utilities.startsWith(g,"../"))&&(g=v._normalizeModuleId(this.fromModulePath+g)),g},v.ROOT=new v(""),v}();F.ModuleIdResolver=n;var M=function(){function v(u,g,C,e,o,h){this.id=u,this.strId=g,this.dependencies=C,this._callback=e,this._errorback=o,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return v._safeInvokeFunction=function(u,g){try{return{returnedValue:u.apply(F.global,g),producedError:null}}catch(C){return{returnedValue:null,producedError:C}}},v._invokeFactory=function(u,g,C,e){return u.isBuild()&&!F.Utilities.isAnonymousModule(g)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(C,e):{returnedValue:C.apply(F.global,e),producedError:null}},v.prototype.complete=function(u,g,C){this._isComplete=!0;var e=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var o=v._invokeFactory(g,this.strId,this._callback,C);e=o.producedError,u.record(22,this.strId),!e&&typeof o.returnedValue!="undefined"&&(!this.exportsPassedIn||F.Utilities.isEmpty(this.exports))&&(this.exports=o.returnedValue)}else this.exports=this._callback;if(e){var h=F.ensureError(e);h.phase="factory",h.moduleId=this.strId,this.error=h,g.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},v.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},v.prototype.isComplete=function(){return this._isComplete},v}();F.Module=M;var R=function(){function v(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return v.prototype.getMaxModuleId=function(){return this._nextId},v.prototype.getModuleId=function(u){var g=this._strModuleIdToIntModuleId.get(u);return typeof g=="undefined"&&(g=this._nextId++,this._strModuleIdToIntModuleId.set(u,g),this._intModuleIdToStrModuleId[g]=u),g},v.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},v}(),E=function(){function v(u){this.id=u}return v.EXPORTS=new v(0),v.MODULE=new v(1),v.REQUIRE=new v(2),v}();F.RegularDependency=E;var a=function(){function v(u,g,C){this.id=u,this.pluginId=g,this.pluginParam=C}return v}();F.PluginDependency=a;var L=function(){function v(u,g,C,e,o){o===void 0&&(o=0),this._env=u,this._scriptLoader=g,this._loaderAvailableTimestamp=o,this._defineFunc=C,this._requireFunc=e,this._moduleIdProvider=new R,this._config=new F.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return v.prototype.reset=function(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},v.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},v.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},v._findRelevantLocationInStack=function(u,g){for(var C=function(i){return i.replace(/\\/g,"/")},e=C(u),o=g.split(/\n/),h=0;h<o.length;h++){var b=o[h].match(/(.*):(\d+):(\d+)\)?$/);if(b){var N=b[1],m=b[2],w=b[3],p=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(p),N=C(N),N===e){var r={line:parseInt(m,10),col:parseInt(w,10)};return r.line===1&&(r.col-="(function (require, define, __filename, __dirname) { ".length),r}}}throw new Error("Could not correlate define call site for needle "+u)},v.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],g=0,C=0,e=this._modules2.length;C<e;C++){var o=this._modules2[C];if(!!o){var h=this._buildInfoPath[o.id]||null,b=this._buildInfoDefineStack[o.id]||null,N=this._buildInfoDependencies[o.id];u[g++]={id:o.strId,path:h,defineLocation:h&&b?v._findRelevantLocationInStack(h,b):null,dependencies:N,shim:null,exports:o.exports}}}return u},v.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new F.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=F.NullLoaderEventRecorder.INSTANCE),this._recorder},v.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},v.prototype.enqueueDefineAnonymousModule=function(u,g){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var C=null;this._config.isBuild()&&(C=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:C,dependencies:u,callback:g}},v.prototype.defineModule=function(u,g,C,e,o,h){var b=this;h===void 0&&(h=new n(u));var N=this._moduleIdProvider.getModuleId(u);if(this._modules2[N]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var m=new M(N,u,this._normalizeDependencies(g,h),C,e,h);this._modules2[N]=m,this._config.isBuild()&&(this._buildInfoDefineStack[N]=o,this._buildInfoDependencies[N]=(m.dependencies||[]).map(function(w){return b._moduleIdProvider.getStrModuleId(w.id)})),this._resolve(m)},v.prototype._normalizeDependency=function(u,g){if(u==="exports")return E.EXPORTS;if(u==="module")return E.MODULE;if(u==="require")return E.REQUIRE;var C=u.indexOf("!");if(C>=0){var e=g.resolveModule(u.substr(0,C)),o=g.resolveModule(u.substr(C+1)),h=this._moduleIdProvider.getModuleId(e+"!"+o),b=this._moduleIdProvider.getModuleId(e);return new a(h,b,o)}return new E(this._moduleIdProvider.getModuleId(g.resolveModule(u)))},v.prototype._normalizeDependencies=function(u,g){for(var C=[],e=0,o=0,h=u.length;o<h;o++)C[e++]=this._normalizeDependency(u[o],g);return C},v.prototype._relativeRequire=function(u,g,C,e){if(typeof g=="string")return this.synchronousRequire(g,u);this.defineModule(F.Utilities.generateAnonymousModule(),g,C,e,null,u)},v.prototype.synchronousRequire=function(u,g){g===void 0&&(g=new n(u));var C=this._normalizeDependency(u,g),e=this._modules2[C.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports},v.prototype.configure=function(u,g){var C=this._config.shouldRecordStats();g?this._config=new F.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!C&&(this._recorder=null)},v.prototype.getConfig=function(){return this._config},v.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var g=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),g.dependencies,g.callback,null,g.stack)}},v.prototype._createLoadError=function(u,g){var C=this,e=this._moduleIdProvider.getStrModuleId(u),o=(this._inverseDependencies2[u]||[]).map(function(b){return C._moduleIdProvider.getStrModuleId(b)}),h=F.ensureError(g);return h.phase="loading",h.moduleId=e,h.neededBy=o,h},v.prototype._onLoadError=function(u,g){var C=this._createLoadError(u,g);this._modules2[u]||(this._modules2[u]=new M(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},null,null));for(var e=[],o=0,h=this._moduleIdProvider.getMaxModuleId();o<h;o++)e[o]=!1;var b=!1,N=[];for(N.push(u),e[u]=!0;N.length>0;){var m=N.shift(),w=this._modules2[m];w&&(b=w.onDependencyError(C)||b);var p=this._inverseDependencies2[m];if(p)for(var o=0,h=p.length;o<h;o++){var r=p[o];e[r]||(N.push(r),e[r]=!0)}}b||this._config.onError(C)},v.prototype._hasDependencyPath=function(u,g){var C=this._modules2[u];if(!C)return!1;for(var e=[],o=0,h=this._moduleIdProvider.getMaxModuleId();o<h;o++)e[o]=!1;var b=[];for(b.push(C),e[u]=!0;b.length>0;){var N=b.shift(),m=N.dependencies;if(m)for(var o=0,h=m.length;o<h;o++){var w=m[o];if(w.id===g)return!0;var p=this._modules2[w.id];p&&!e[w.id]&&(e[w.id]=!0,b.push(p))}}return!1},v.prototype._findCyclePath=function(u,g,C){if(u===g||C===50)return[u];var e=this._modules2[u];if(!e)return null;var o=e.dependencies;if(o)for(var h=0,b=o.length;h<b;h++){var N=this._findCyclePath(o[h].id,g,C+1);if(N!==null)return N.push(u),N}return null},v.prototype._createRequire=function(u){var g=this,C=function(e,o,h){return g._relativeRequire(u,e,o,h)};return C.toUrl=function(e){return g._config.requireToUrl(u.resolveModule(e))},C.getStats=function(){return g.getLoaderEvents()},C.hasDependencyCycle=function(){return g._hasDependencyCycle},C.config=function(e,o){o===void 0&&(o=!1),g.configure(e,o)},C.__$__nodeRequire=F.global.nodeRequire,C},v.prototype._loadModule=function(u){var g=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var C=this._moduleIdProvider.getStrModuleId(u),e=this._config.moduleIdToPaths(C),o=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(C.indexOf("/")===-1||o.test(C))&&e.push("node|"+C);var h=-1,b=function(N){if(h++,h>=e.length)g._onLoadError(u,N);else{var m=e[h],w=g.getRecorder();if(g._config.isBuild()&&m==="empty:"){g._buildInfoPath[u]=m,g.defineModule(g._moduleIdProvider.getStrModuleId(u),[],null,null,null),g._onLoad(u);return}w.record(10,m),g._scriptLoader.load(g,m,function(){g._config.isBuild()&&(g._buildInfoPath[u]=m),w.record(11,m),g._onLoad(u)},function(p){w.record(12,m),b(p)})}};b(null)}},v.prototype._loadPluginDependency=function(u,g){var C=this;if(!(this._modules2[g.id]||this._knownModules2[g.id])){this._knownModules2[g.id]=!0;var e=function(o){C.defineModule(C._moduleIdProvider.getStrModuleId(g.id),[],o,null,null)};e.error=function(o){C._config.onError(C._createLoadError(g.id,o))},u.load(g.pluginParam,this._createRequire(n.ROOT),e,this._config.getOptionsLiteral())}},v.prototype._resolve=function(u){var g=this,C=u.dependencies;if(C)for(var e=0,o=C.length;e<o;e++){var h=C[e];if(h===E.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(h===E.MODULE){u.unresolvedDependenciesCount--;continue}if(h===E.REQUIRE){u.unresolvedDependenciesCount--;continue}var b=this._modules2[h.id];if(b&&b.isComplete()){if(b.error){u.onDependencyError(b.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var N=this._findCyclePath(h.id,u.id,0)||[];N.reverse(),N.push(h.id),console.warn(N.map(function(p){return g._moduleIdProvider.getStrModuleId(p)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(u.id),h instanceof a){var m=this._modules2[h.pluginId];if(m&&m.isComplete()){this._loadPluginDependency(m.exports,h);continue}var w=this._inversePluginDependencies2.get(h.pluginId);w||(w=[],this._inversePluginDependencies2.set(h.pluginId,w)),w.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},v.prototype._onModuleComplete=function(u){var g=this,C=this.getRecorder();if(!u.isComplete()){var e=u.dependencies,o=[];if(e)for(var h=0,b=e.length;h<b;h++){var N=e[h];if(N===E.EXPORTS){o[h]=u.exports;continue}if(N===E.MODULE){o[h]={id:u.strId,config:function(){return g._config.getConfigForModule(u.strId)}};continue}if(N===E.REQUIRE){o[h]=this._createRequire(u.moduleIdResolver);continue}var m=this._modules2[N.id];if(m){o[h]=m.exports;continue}o[h]=null}u.complete(C,this._config,o);var w=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,w)for(var h=0,b=w.length;h<b;h++){var p=w[h],r=this._modules2[p];r.unresolvedDependenciesCount--,r.unresolvedDependenciesCount===0&&this._onModuleComplete(r)}var i=this._inversePluginDependencies2.get(u.id);if(i){this._inversePluginDependencies2.delete(u.id);for(var h=0,b=i.length;h<b;h++)this._loadPluginDependency(u.exports,i[h])}}},v}();F.ModuleManager=L})(X||(X={}));var $,X;(function(F){var n=new F.Environment,M=null,R=function(v,u,g){typeof v!="string"&&(g=u,u=v,v=null),(typeof u!="object"||!Array.isArray(u))&&(g=u,u=null),u||(u=["require","exports","module"]),v?M.defineModule(v,u,g,null,null):M.enqueueDefineAnonymousModule(u,g)};R.amd={jQuery:!0};var E=function(v,u){u===void 0&&(u=!1),M.configure(v,u)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){E(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(F.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=E,a.getConfig=function(){return M.getConfig().getOptionsLiteral()},a.reset=function(){M=M.reset()},a.getBuildInfo=function(){return M.getBuildInfo()},a.getStats=function(){return M.getLoaderEvents()},a.define=R;function L(){if(typeof F.global.require!="undefined"||typeof require!="undefined"){var v=F.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){var u=F.ensureRecordedNodeRequire(M.getRecorder(),v);F.global.nodeRequire=u,a.nodeRequire=u,a.__$__nodeRequire=u}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=a,require=a):(n.isElectronRenderer||(F.global.define=R),F.global.require=a)}F.init=L,(typeof F.global.define!="function"||!F.global.define.amd)&&(M=new F.ModuleManager(n,F.createScriptLoader(n),R,a,F.Utilities.getHighPerformanceTimestamp()),typeof F.global.require!="undefined"&&typeof F.global.require!="function"&&a.config(F.global.require),$=function(){return R.apply(null,arguments)},$.amd=R.amd,typeof doNotInitLoader=="undefined"&&L())})(X||(X={})),$(j[15],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.splice=n.insertInto=n.asArray=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.flatten=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function M(c,S=0){return c[c.length-(1+S)]}n.tail=M;function R(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}n.tail2=R;function E(c,S,A=(y,P)=>y===P){if(c===S)return!0;if(!c||!S||c.length!==S.length)return!1;for(let y=0,P=c.length;y<P;y++)if(!A(c[y],S[y]))return!1;return!0}n.equals=E;function a(c,S,A){let y=0,P=c.length-1;for(;y<=P;){const k=(y+P)/2|0,O=A(c[k],S);if(O<0)y=k+1;else if(O>0)P=k-1;else return k}return-(y+1)}n.binarySearch=a;function L(c,S){let A=0,y=c.length;if(y===0)return 0;for(;A<y;){const P=Math.floor((A+y)/2);S(c[P])?y=P:A=P+1}return A}n.findFirstInSorted=L;function v(c,S,A){if(c=c|0,c>=S.length)throw new TypeError("invalid index");let y=S[Math.floor(S.length*Math.random())],P=[],k=[],O=[];for(let U of S){const T=A(U,y);T<0?P.push(U):T>0?k.push(U):O.push(U)}return c<P.length?v(c,P,A):c<P.length+O.length?O[0]:v(c-(P.length+O.length),k,A)}n.quickSelect=v;function u(c,S){const A=[];let y;for(const P of c.slice(0).sort(S))!y||S(y[0],P)!==0?(y=[P],A.push(y)):y.push(P);return A}n.groupBy=u;function g(c){return c.filter(S=>!!S)}n.coalesce=g;function C(c){return!Array.isArray(c)||c.length===0}n.isFalsyOrEmpty=C;function e(c){return Array.isArray(c)&&c.length>0}n.isNonEmptyArray=e;function o(c,S=A=>A){const A=new Set;return c.filter(y=>{const P=S(y);return A.has(P)?!1:(A.add(P),!0)})}n.distinct=o;function h(c,S){const A=b(c,S);if(A!==-1)return c[A]}n.findLast=h;function b(c,S){for(let A=c.length-1;A>=0;A--){const y=c[A];if(S(y))return A}return-1}n.lastIndex=b;function N(c,S){return c.length>0?c[0]:S}n.firstOrDefault=N;function m(c){return[].concat(...c)}n.flatten=m;function w(c,S){let A=typeof S=="number"?c:0;typeof S=="number"?A=c:(A=0,S=c);const y=[];if(A<=S)for(let P=A;P<S;P++)y.push(P);else for(let P=A;P>S;P--)y.push(P);return y}n.range=w;function p(c,S,A){const y=c.slice(0,S),P=c.slice(S);return y.concat(A,P)}n.arrayInsert=p;function r(c,S){const A=c.indexOf(S);A>-1&&(c.splice(A,1),c.unshift(S))}n.pushToStart=r;function i(c,S){const A=c.indexOf(S);A>-1&&(c.splice(A,1),c.push(S))}n.pushToEnd=i;function s(c){return Array.isArray(c)?c:[c]}n.asArray=s;function f(c,S,A){const y=l(c,S),P=c.length,k=A.length;c.length=P+k;for(let O=P-1;O>=y;O--)c[O+k]=c[O];for(let O=0;O<k;O++)c[O+y]=A[O]}n.insertInto=f;function d(c,S,A,y){const P=l(c,S),k=c.splice(P,A);return f(c,P,y),k}n.splice=d;function l(c,S){return S<0?Math.max(S+c.length,0):Math.min(S,c.length)}class _{constructor(S){this.items=S,this.firstIdx=0,this.lastIdx=this.items.length-1}takeWhile(S){let A=this.firstIdx;for(;A<this.items.length&&S(this.items[A]);)A++;const y=A===this.firstIdx?null:this.items.slice(this.firstIdx,A);return this.firstIdx=A,y}takeFromEndWhile(S){let A=this.lastIdx;for(;A>=0&&S(this.items[A]);)A--;const y=A===this.lastIdx?null:this.items.slice(A+1,this.lastIdx+1);return this.lastIdx=A,y}peek(){return this.items[this.firstIdx]}dequeue(){const S=this.items[this.firstIdx];return this.firstIdx++,S}takeCount(S){const A=this.items.slice(this.firstIdx,this.firstIdx+S);return this.firstIdx+=S,A}}n.ArrayQueue=_}),$(j[16],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class M{constructor(E,a,L,v){this.originalStart=E,this.originalLength=a,this.modifiedStart=L,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=M}),$(j[8],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.isPromiseCanceledError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?new Error(h.message+`

`+h.stack):h},0)}}emit(h){this.listeners.forEach(b=>{b(h)})}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}n.ErrorHandler=M,n.errorHandler=new M;function R(o){v(o)||n.errorHandler.onUnexpectedError(o)}n.onUnexpectedError=R;function E(o){v(o)||n.errorHandler.onUnexpectedExternalError(o)}n.onUnexpectedExternalError=E;function a(o){if(o instanceof Error){let{name:h,message:b}=o;const N=o.stacktrace||o.stack;return{$isError:!0,name:h,message:b,stack:N}}return o}n.transformErrorForSerialization=a;const L="Canceled";function v(o){return o instanceof Error&&o.name===L&&o.message===L}n.isPromiseCanceledError=v;function u(){const o=new Error(L);return o.name=o.message,o}n.canceled=u;function g(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}n.illegalArgument=g;function C(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}n.illegalState=C;class e extends Error{constructor(h){super("NotSupported");h&&(this.message=h)}}n.NotSupportedError=e}),$(j[17],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function M(R){const E=this;let a=!1,L;return function(){return a||(a=!0,L=R.apply(E,arguments)),L}}n.once=M}),$(j[18],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var M;(function(R){function E(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=E;const a=Object.freeze([]);function L(){return a}R.empty=L;function*v(s){yield s}R.single=v;function u(s){return s||a}R.from=u;function g(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=g;function C(s){return s[Symbol.iterator]().next().value}R.first=C;function e(s,f){for(const d of s)if(f(d))return!0;return!1}R.some=e;function o(s,f){for(const d of s)if(f(d))return d}R.find=o;function*h(s,f){for(const d of s)f(d)&&(yield d)}R.filter=h;function*b(s,f){let d=0;for(const l of s)yield f(l,d++)}R.map=b;function*N(...s){for(const f of s)for(const d of f)yield d}R.concat=N;function*m(s){for(const f of s)for(const d of f)yield d}R.concatNested=m;function w(s,f,d){let l=d;for(const _ of s)l=f(l,_);return l}R.reduce=w;function*p(s,f,d=s.length){for(f<0&&(f+=s.length),d<0?d+=s.length:d>s.length&&(d=s.length);f<d;f++)yield s[f]}R.slice=p;function r(s,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,s];const l=s[Symbol.iterator]();for(let _=0;_<f;_++){const c=l.next();if(c.done)return[d,R.empty()];d.push(c.value)}return[d,{[Symbol.iterator](){return l}}]}R.consume=r;function i(s,f,d=(l,_)=>l===_){const l=s[Symbol.iterator](),_=f[Symbol.iterator]();for(;;){const c=l.next(),S=_.next();if(c.done!==S.done)return!1;if(c.done)return!0;if(!d(c.value,S.value))return!1}}R.equals=i})(M=n.Iterable||(n.Iterable={}))}),$(j[19],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(o,h){this._keyCodeToStr[o]=h,this._strToKeyCode[h.toLowerCase()]=o}keyCodeToStr(o){return this._keyCodeToStr[o]}strToKeyCode(o){return this._strToKeyCode[o.toLowerCase()]||0}}const R=new M,E=new M,a=new M;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const L=[],v=Object.create(null),u=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",o=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let h=[],b=[];for(const N of o){const[m,w,p,r,i,s,f,d,l,_]=N;if(b[p]||(b[p]=!0,L[p]=r,v[r]=p,u[r.toLowerCase()]=p,w&&(n.IMMUTABLE_CODE_TO_KEY_CODE[p]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[i]=p))),!h[i]){if(h[i]=!0,!s)throw new Error(`String representation missing for key code ${i} around scan code ${r}`);R.define(i,s),E.define(i,l||s),a.define(i,_||l||s)}f&&(n.EVENT_KEY_CODE_MAP[f]=i),d&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=i)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var g;(function(e){function o(p){return R.keyCodeToStr(p)}e.toString=o;function h(p){return R.strToKeyCode(p)}e.fromString=h;function b(p){return E.keyCodeToStr(p)}e.toUserSettingsUS=b;function N(p){return a.keyCodeToStr(p)}e.toUserSettingsGeneral=N;function m(p){return E.strToKeyCode(p)||a.strToKeyCode(p)}e.fromUserSettings=m;function w(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return R.keyCodeToStr(p)}e.toElectronAccelerator=w})(g=n.KeyCodeUtils||(n.KeyCodeUtils={}));function C(e,o){const h=(o&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=C}),$(j[9],G([0,1,17,18]),function(F,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ImmortalReference=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const E=!1;let a=null;function L(s){a=s}if(n.setDisposableTracker=L,E){const s="__is_disposable_tracked__";L(new class{trackDisposable(f){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[s]||console.log(d)},3e3)}setParent(f,d){if(f&&f!==p.None)try{f[s]=!0}catch(l){}}markAsDisposed(f){if(f&&f!==p.None)try{f[s]=!0}catch(d){}}markAsSingleton(f){}})}function v(s){return a==null||a.trackDisposable(s),s}function u(s){a==null||a.markAsDisposed(s)}function g(s,f){a==null||a.setParent(s,f)}function C(s,f){if(!!a)for(const d of s)a.setParent(d,f)}function e(s){return a==null||a.markAsSingleton(s),s}n.markAsSingleton=e;class o extends Error{constructor(f){super(`Encountered errors while disposing of store. Errors: [${f.join(", ")}]`);this.errors=f}}n.MultiDisposeError=o;function h(s){return typeof s.dispose=="function"&&s.dispose.length===0}n.isDisposable=h;function b(s){if(R.Iterable.is(s)){let f=[];for(const d of s)if(d)try{d.dispose()}catch(l){f.push(l)}if(f.length===1)throw f[0];if(f.length>1)throw new o(f);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}n.dispose=b;function N(...s){const f=m(()=>b(s));return C(s,f),f}n.combinedDisposable=N;function m(s){const f=v({dispose:(0,M.once)(()=>{u(f),s()})});return f}n.toDisposable=m;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return g(f,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}}n.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new w,v(this),g(this._store,this)}dispose(){u(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}n.Disposable=p,p.None=Object.freeze({dispose(){}});class r{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){var d;this._isDisposed||f===this._value||((d=this._value)===null||d===void 0||d.dispose(),f&&g(f,this),this._value=f)}clear(){this.value=void 0}dispose(){var f;this._isDisposed=!0,u(this),(f=this._value)===null||f===void 0||f.dispose(),this._value=void 0}clearAndLeak(){const f=this._value;return this._value=void 0,f&&g(f,null),f}}n.MutableDisposable=r;class i{constructor(f){this.object=f}dispose(){}}n.ImmortalReference=i}),$(j[20],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class M{constructor(a){this.element=a,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class R{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let a=this._first;for(;a!==M.Undefined;){const L=a.next;a.prev=M.Undefined,a.next=M.Undefined,a=L}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(a){return this._insert(a,!1)}push(a){return this._insert(a,!0)}_insert(a,L){const v=new M(a);if(this._first===M.Undefined)this._first=v,this._last=v;else if(L){const g=this._last;this._last=v,v.prev=g,g.next=v}else{const g=this._first;this._first=v,v.next=g,g.prev=v}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(v))}}shift(){if(this._first!==M.Undefined){const a=this._first.element;return this._remove(this._first),a}}pop(){if(this._last!==M.Undefined){const a=this._last.element;return this._remove(this._last),a}}_remove(a){if(a.prev!==M.Undefined&&a.next!==M.Undefined){const L=a.prev;L.next=a.next,a.next.prev=L}else a.prev===M.Undefined&&a.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):a.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):a.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let a=this._first;for(;a!==M.Undefined;)yield a.element,a=a.next}}n.LinkedList=R}),$(j[2],G([0,1]),function(F,n){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isLittleEndian=n.OS=n.setImmediate=n.setTimeout0=n.locale=n.language=n.userAgent=n.isIOS=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=void 0;const R="en";let E=!1,a=!1,L=!1,v=!1,u=!1,g=!1,C=!1,e=!1,o,h=R,b,N;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?m=n.globals.vscode.process:typeof process!="undefined"&&(m=process);const w=typeof((M=m==null?void 0:m.versions)===null||M===void 0?void 0:M.electron)=="string",p=w&&(m==null?void 0:m.type)==="renderer";if(typeof navigator=="object"&&!p)N=navigator.userAgent,E=N.indexOf("Windows")>=0,a=N.indexOf("Macintosh")>=0,e=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=N.indexOf("Linux")>=0,g=!0,o=navigator.language,h=o;else if(typeof m=="object"){E=m.platform==="win32",a=m.platform==="darwin",L=m.platform==="linux",v=L&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,C=w,o=R,h=R;const d=m.env.VSCODE_NLS_CONFIG;if(d)try{const l=JSON.parse(d),_=l.availableLanguages["*"];o=l.locale,h=_||R,b=l._translationsConfigFile}catch(l){}u=!0}else console.error("Unable to resolve platform.");let r=0;a?r=1:E?r=3:L&&(r=2),n.isWindows=E,n.isMacintosh=a,n.isLinux=L,n.isNative=u,n.isWeb=g,n.isIOS=e,n.userAgent=N,n.language=h,n.locale=o,n.setTimeout0=(()=>{if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let d=[];n.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let c=0,S=d.length;c<S;c++){const A=d[c];if(A.id===_.data.vscodeScheduleAsyncWork){d.splice(c,1),A.callback();return}}});let l=0;return _=>{const c=++l;d.push({id:c,callback:_}),n.globals.postMessage({vscodeScheduleAsyncWork:c},"*")}}return d=>setTimeout(d)})(),n.setImmediate=function(){if(n.globals.setImmediate)return n.globals.setImmediate.bind(n.globals);if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts)return n.setTimeout0;if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const l=Promise.resolve();return _=>l.then(_)}(),n.OS=a||e?2:E?1:3;let i=!0,s=!1;function f(){if(!s){s=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,i=new Uint16Array(d.buffer)[0]===(2<<8)+1}return i}n.isLittleEndian=f}),$(j[21],G([0,1,2]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let R;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.process!="undefined"){const E=M.globals.vscode.process;R={get platform(){return E.platform},get arch(){return E.arch},get env(){return E.env},cwd(){return E.cwd()}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=R.cwd,n.env=R.env,n.platform=R.platform}),$(j[22],G([0,1,21]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const R=65,E=97,a=90,L=122,v=46,u=47,g=92,C=58,e=63;class o extends Error{constructor(i,s,f){let d;typeof s=="string"&&s.indexOf("not ")===0?(d="must not be",s=s.replace(/^not /,"")):d="must be";const l=i.indexOf(".")!==-1?"property":"argument";let _=`The "${i}" ${l} ${d} of type ${s}`;_+=`. Received type ${typeof f}`,super(_),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,i){if(typeof r!="string")throw new o(i,"string",r)}function b(r){return r===u||r===g}function N(r){return r===u}function m(r){return r>=R&&r<=a||r>=E&&r<=L}function w(r,i,s,f){let d="",l=0,_=-1,c=0,S=0;for(let A=0;A<=r.length;++A){if(A<r.length)S=r.charCodeAt(A);else{if(f(S))break;S=u}if(f(S)){if(!(_===A-1||c===1))if(c===2){if(d.length<2||l!==2||d.charCodeAt(d.length-1)!==v||d.charCodeAt(d.length-2)!==v){if(d.length>2){const y=d.lastIndexOf(s);y===-1?(d="",l=0):(d=d.slice(0,y),l=d.length-1-d.lastIndexOf(s)),_=A,c=0;continue}else if(d.length!==0){d="",l=0,_=A,c=0;continue}}i&&(d+=d.length>0?`${s}..`:"..",l=2)}else d.length>0?d+=`${s}${r.slice(_+1,A)}`:d=r.slice(_+1,A),l=A-_-1;_=A,c=0}else S===v&&c!==-1?++c:c=-1}return d}function p(r,i){if(i===null||typeof i!="object")throw new o("pathObject","Object",i);const s=i.dir||i.root,f=i.base||`${i.name||""}${i.ext||""}`;return s?s===i.root?`${s}${f}`:`${s}${r}${f}`:f}n.win32={resolve(...r){let i="",s="",f=!1;for(let d=r.length-1;d>=-1;d--){let l;if(d>=0){if(l=r[d],h(l,"path"),l.length===0)continue}else i.length===0?l=M.cwd():(l=M.env[`=${i}`]||M.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==i.toLowerCase()&&l.charCodeAt(2)===g)&&(l=`${i}\\`));const _=l.length;let c=0,S="",A=!1;const y=l.charCodeAt(0);if(_===1)b(y)&&(c=1,A=!0);else if(b(y))if(A=!0,b(l.charCodeAt(1))){let P=2,k=P;for(;P<_&&!b(l.charCodeAt(P));)P++;if(P<_&&P!==k){const O=l.slice(k,P);for(k=P;P<_&&b(l.charCodeAt(P));)P++;if(P<_&&P!==k){for(k=P;P<_&&!b(l.charCodeAt(P));)P++;(P===_||P!==k)&&(S=`\\\\${O}\\${l.slice(k,P)}`,c=P)}}}else c=1;else m(y)&&l.charCodeAt(1)===C&&(S=l.slice(0,2),c=2,_>2&&b(l.charCodeAt(2))&&(A=!0,c=3));if(S.length>0)if(i.length>0){if(S.toLowerCase()!==i.toLowerCase())continue}else i=S;if(f){if(i.length>0)break}else if(s=`${l.slice(c)}\\${s}`,f=A,A&&i.length>0)break}return s=w(s,!f,"\\",b),f?`${i}\\${s}`:`${i}${s}`||"."},normalize(r){h(r,"path");const i=r.length;if(i===0)return".";let s=0,f,d=!1;const l=r.charCodeAt(0);if(i===1)return N(l)?"\\":r;if(b(l))if(d=!0,b(r.charCodeAt(1))){let c=2,S=c;for(;c<i&&!b(r.charCodeAt(c));)c++;if(c<i&&c!==S){const A=r.slice(S,c);for(S=c;c<i&&b(r.charCodeAt(c));)c++;if(c<i&&c!==S){for(S=c;c<i&&!b(r.charCodeAt(c));)c++;if(c===i)return`\\\\${A}\\${r.slice(S)}\\`;c!==S&&(f=`\\\\${A}\\${r.slice(S,c)}`,s=c)}}}else s=1;else m(l)&&r.charCodeAt(1)===C&&(f=r.slice(0,2),s=2,i>2&&b(r.charCodeAt(2))&&(d=!0,s=3));let _=s<i?w(r.slice(s),!d,"\\",b):"";return _.length===0&&!d&&(_="."),_.length>0&&b(r.charCodeAt(i-1))&&(_+="\\"),f===void 0?d?`\\${_}`:_:d?`${f}\\${_}`:`${f}${_}`},isAbsolute(r){h(r,"path");const i=r.length;if(i===0)return!1;const s=r.charCodeAt(0);return b(s)||i>2&&m(s)&&r.charCodeAt(1)===C&&b(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,s;for(let l=0;l<r.length;++l){const _=r[l];h(_,"path"),_.length>0&&(i===void 0?i=s=_:i+=`\\${_}`)}if(i===void 0)return".";let f=!0,d=0;if(typeof s=="string"&&b(s.charCodeAt(0))){++d;const l=s.length;l>1&&b(s.charCodeAt(1))&&(++d,l>2&&(b(s.charCodeAt(2))?++d:f=!1))}if(f){for(;d<i.length&&b(i.charCodeAt(d));)d++;d>=2&&(i=`\\${i.slice(d)}`)}return n.win32.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i)return"";const s=n.win32.resolve(r),f=n.win32.resolve(i);if(s===f||(r=s.toLowerCase(),i=f.toLowerCase(),r===i))return"";let d=0;for(;d<r.length&&r.charCodeAt(d)===g;)d++;let l=r.length;for(;l-1>d&&r.charCodeAt(l-1)===g;)l--;const _=l-d;let c=0;for(;c<i.length&&i.charCodeAt(c)===g;)c++;let S=i.length;for(;S-1>c&&i.charCodeAt(S-1)===g;)S--;const A=S-c,y=_<A?_:A;let P=-1,k=0;for(;k<y;k++){const U=r.charCodeAt(d+k);if(U!==i.charCodeAt(c+k))break;U===g&&(P=k)}if(k!==y){if(P===-1)return f}else{if(A>y){if(i.charCodeAt(c+k)===g)return f.slice(c+k+1);if(k===2)return f.slice(c+k)}_>y&&(r.charCodeAt(d+k)===g?P=k:k===2&&(P=3)),P===-1&&(P=0)}let O="";for(k=d+P+1;k<=l;++k)(k===l||r.charCodeAt(k)===g)&&(O+=O.length===0?"..":"\\..");return c+=P,O.length>0?`${O}${f.slice(c,S)}`:(f.charCodeAt(c)===g&&++c,f.slice(c,S))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const i=n.win32.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===g){if(i.charCodeAt(1)===g){const s=i.charCodeAt(2);if(s!==e&&s!==v)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&i.charCodeAt(1)===C&&i.charCodeAt(2)===g)return`\\\\?\\${i}`;return r},dirname(r){h(r,"path");const i=r.length;if(i===0)return".";let s=-1,f=0;const d=r.charCodeAt(0);if(i===1)return b(d)?r:".";if(b(d)){if(s=f=1,b(r.charCodeAt(1))){let c=2,S=c;for(;c<i&&!b(r.charCodeAt(c));)c++;if(c<i&&c!==S){for(S=c;c<i&&b(r.charCodeAt(c));)c++;if(c<i&&c!==S){for(S=c;c<i&&!b(r.charCodeAt(c));)c++;if(c===i)return r;c!==S&&(s=f=c+1)}}}}else m(d)&&r.charCodeAt(1)===C&&(s=i>2&&b(r.charCodeAt(2))?3:2,f=s);let l=-1,_=!0;for(let c=i-1;c>=f;--c)if(b(r.charCodeAt(c))){if(!_){l=c;break}}else _=!1;if(l===-1){if(s===-1)return".";l=s}return r.slice(0,l)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let s=0,f=-1,d=!0,l;if(r.length>=2&&m(r.charCodeAt(0))&&r.charCodeAt(1)===C&&(s=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let _=i.length-1,c=-1;for(l=r.length-1;l>=s;--l){const S=r.charCodeAt(l);if(b(S)){if(!d){s=l+1;break}}else c===-1&&(d=!1,c=l+1),_>=0&&(S===i.charCodeAt(_)?--_==-1&&(f=l):(_=-1,f=c))}return s===f?f=c:f===-1&&(f=r.length),r.slice(s,f)}for(l=r.length-1;l>=s;--l)if(b(r.charCodeAt(l))){if(!d){s=l+1;break}}else f===-1&&(d=!1,f=l+1);return f===-1?"":r.slice(s,f)},extname(r){h(r,"path");let i=0,s=-1,f=0,d=-1,l=!0,_=0;r.length>=2&&r.charCodeAt(1)===C&&m(r.charCodeAt(0))&&(i=f=2);for(let c=r.length-1;c>=i;--c){const S=r.charCodeAt(c);if(b(S)){if(!l){f=c+1;break}continue}d===-1&&(l=!1,d=c+1),S===v?s===-1?s=c:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||d===-1||_===0||_===1&&s===d-1&&s===f+1?"":r.slice(s,d)},format:p.bind(null,"\\"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const s=r.length;let f=0,d=r.charCodeAt(0);if(s===1)return b(d)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(b(d)){if(f=1,b(r.charCodeAt(1))){let P=2,k=P;for(;P<s&&!b(r.charCodeAt(P));)P++;if(P<s&&P!==k){for(k=P;P<s&&b(r.charCodeAt(P));)P++;if(P<s&&P!==k){for(k=P;P<s&&!b(r.charCodeAt(P));)P++;P===s?f=P:P!==k&&(f=P+1)}}}}else if(m(d)&&r.charCodeAt(1)===C){if(s<=2)return i.root=i.dir=r,i;if(f=2,b(r.charCodeAt(2))){if(s===3)return i.root=i.dir=r,i;f=3}}f>0&&(i.root=r.slice(0,f));let l=-1,_=f,c=-1,S=!0,A=r.length-1,y=0;for(;A>=f;--A){if(d=r.charCodeAt(A),b(d)){if(!S){_=A+1;break}continue}c===-1&&(S=!1,c=A+1),d===v?l===-1?l=A:y!==1&&(y=1):l!==-1&&(y=-1)}return c!==-1&&(l===-1||y===0||y===1&&l===c-1&&l===_+1?i.base=i.name=r.slice(_,c):(i.name=r.slice(_,l),i.base=r.slice(_,c),i.ext=r.slice(l,c))),_>0&&_!==f?i.dir=r.slice(0,_-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...r){let i="",s=!1;for(let f=r.length-1;f>=-1&&!s;f--){const d=f>=0?r[f]:M.cwd();h(d,"path"),d.length!==0&&(i=`${d}/${i}`,s=d.charCodeAt(0)===u)}return i=w(i,!s,"/",N),s?`/${i}`:i.length>0?i:"."},normalize(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u,s=r.charCodeAt(r.length-1)===u;return r=w(r,!i,"/",N),r.length===0?i?"/":s?"./":".":(s&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return h(r,"path"),r.length>0&&r.charCodeAt(0)===u},join(...r){if(r.length===0)return".";let i;for(let s=0;s<r.length;++s){const f=r[s];h(f,"path"),f.length>0&&(i===void 0?i=f:i+=`/${f}`)}return i===void 0?".":n.posix.normalize(i)},relative(r,i){if(h(r,"from"),h(i,"to"),r===i||(r=n.posix.resolve(r),i=n.posix.resolve(i),r===i))return"";const s=1,f=r.length,d=f-s,l=1,_=i.length-l,c=d<_?d:_;let S=-1,A=0;for(;A<c;A++){const P=r.charCodeAt(s+A);if(P!==i.charCodeAt(l+A))break;P===u&&(S=A)}if(A===c)if(_>c){if(i.charCodeAt(l+A)===u)return i.slice(l+A+1);if(A===0)return i.slice(l+A)}else d>c&&(r.charCodeAt(s+A)===u?S=A:A===0&&(S=0));let y="";for(A=s+S+1;A<=f;++A)(A===f||r.charCodeAt(A)===u)&&(y+=y.length===0?"..":"/..");return`${y}${i.slice(l+S)}`},toNamespacedPath(r){return r},dirname(r){if(h(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u;let s=-1,f=!0;for(let d=r.length-1;d>=1;--d)if(r.charCodeAt(d)===u){if(!f){s=d;break}}else f=!1;return s===-1?i?"/":".":i&&s===1?"//":r.slice(0,s)},basename(r,i){i!==void 0&&h(i,"ext"),h(r,"path");let s=0,f=-1,d=!0,l;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let _=i.length-1,c=-1;for(l=r.length-1;l>=0;--l){const S=r.charCodeAt(l);if(S===u){if(!d){s=l+1;break}}else c===-1&&(d=!1,c=l+1),_>=0&&(S===i.charCodeAt(_)?--_==-1&&(f=l):(_=-1,f=c))}return s===f?f=c:f===-1&&(f=r.length),r.slice(s,f)}for(l=r.length-1;l>=0;--l)if(r.charCodeAt(l)===u){if(!d){s=l+1;break}}else f===-1&&(d=!1,f=l+1);return f===-1?"":r.slice(s,f)},extname(r){h(r,"path");let i=-1,s=0,f=-1,d=!0,l=0;for(let _=r.length-1;_>=0;--_){const c=r.charCodeAt(_);if(c===u){if(!d){s=_+1;break}continue}f===-1&&(d=!1,f=_+1),c===v?i===-1?i=_:l!==1&&(l=1):i!==-1&&(l=-1)}return i===-1||f===-1||l===0||l===1&&i===f-1&&i===s+1?"":r.slice(i,f)},format:p.bind(null,"/"),parse(r){h(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const s=r.charCodeAt(0)===u;let f;s?(i.root="/",f=1):f=0;let d=-1,l=0,_=-1,c=!0,S=r.length-1,A=0;for(;S>=f;--S){const y=r.charCodeAt(S);if(y===u){if(!c){l=S+1;break}continue}_===-1&&(c=!1,_=S+1),y===v?d===-1?d=S:A!==1&&(A=1):d!==-1&&(A=-1)}if(_!==-1){const y=l===0&&s?1:l;d===-1||A===0||A===1&&d===_-1&&d===l+1?i.base=i.name=r.slice(y,_):(i.name=r.slice(y,d),i.base=r.slice(y,_),i.ext=r.slice(d,_))}return l>0?i.dir=r.slice(0,l-1):s&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=M.platform==="win32"?n.win32.normalize:n.posix.normalize,n.resolve=M.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=M.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=M.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=M.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=M.platform==="win32"?n.win32.extname:n.posix.extname,n.sep=M.platform==="win32"?n.win32.sep:n.posix.sep}),$(j[10],G([0,1,2]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const R=M.globals.performance&&typeof M.globals.performance.now=="function";class E{constructor(L){this._highResolution=R&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new E(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}n.StopWatch=E}),$(j[7],G([0,1,8,9,20,10]),function(F,n,M,R,E,a){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.DebounceEmitter=n.PauseableEmitter=n.Emitter=n.Event=void 0;var L;(function(N){N.None=()=>R.Disposable.None;function m(U){return(T,H=null,W)=>{let t=!1,V;return V=U(Y=>{if(!t)return V?V.dispose():t=!0,T.call(H,Y)},null,W),t&&V.dispose(),V}}N.once=m;function w(U,T){return d((H,W=null,t)=>U(V=>H.call(W,T(V)),null,t))}N.map=w;function p(U,T){return d((H,W=null,t)=>U(V=>{T(V),H.call(W,V)},null,t))}N.forEach=p;function r(U,T){return d((H,W=null,t)=>U(V=>T(V)&&H.call(W,V),null,t))}N.filter=r;function i(U){return U}N.signal=i;function s(...U){return(T,H=null,W)=>(0,R.combinedDisposable)(...U.map(t=>t(V=>T.call(H,V),null,W)))}N.any=s;function f(U,T,H){let W=H;return w(U,t=>(W=T(W,t),W))}N.reduce=f;function d(U){let T;const H=new C({onFirstListenerAdd(){T=U(H.fire,H)},onLastListenerRemove(){T.dispose()}});return H.event}function l(U,T,H=100,W=!1,t){let V,Y,Z,se=0;const le=new C({leakWarningThreshold:t,onFirstListenerAdd(){V=U(oe=>{se++,Y=T(Y,oe),W&&!Z&&(le.fire(Y),Y=void 0),clearTimeout(Z),Z=setTimeout(()=>{const ae=Y;Y=void 0,Z=void 0,(!W||se>1)&&le.fire(ae),se=0},H)})},onLastListenerRemove(){V.dispose()}});return le.event}N.debounce=l;function _(U,T=(H,W)=>H===W){let H=!0,W;return r(U,t=>{const V=H||!T(t,W);return H=!1,W=t,V})}N.latch=_;function c(U,T){return[N.filter(U,T),N.filter(U,H=>!T(H))]}N.split=c;function S(U,T=!1,H=[]){let W=H.slice(),t=U(Z=>{W?W.push(Z):Y.fire(Z)});const V=()=>{W&&W.forEach(Z=>Y.fire(Z)),W=null},Y=new C({onFirstListenerAdd(){t||(t=U(Z=>Y.fire(Z)))},onFirstListenerDidAdd(){W&&(T?setTimeout(V):V())},onLastListenerRemove(){t&&t.dispose(),t=null}});return Y.event}N.buffer=S;class A{constructor(T){this.event=T}map(T){return new A(w(this.event,T))}forEach(T){return new A(p(this.event,T))}filter(T){return new A(r(this.event,T))}reduce(T,H){return new A(f(this.event,T,H))}latch(){return new A(_(this.event))}debounce(T,H=100,W=!1,t){return new A(l(this.event,T,H,W,t))}on(T,H,W){return this.event(T,H,W)}once(T,H,W){return m(this.event)(T,H,W)}}function y(U){return new A(U)}N.chain=y;function P(U,T,H=W=>W){const W=(...Z)=>Y.fire(H(...Z)),t=()=>U.on(T,W),V=()=>U.removeListener(T,W),Y=new C({onFirstListenerAdd:t,onLastListenerRemove:V});return Y.event}N.fromNodeEventEmitter=P;function k(U,T,H=W=>W){const W=(...Z)=>Y.fire(H(...Z)),t=()=>U.addEventListener(T,W),V=()=>U.removeEventListener(T,W),Y=new C({onFirstListenerAdd:t,onLastListenerRemove:V});return Y.event}N.fromDOMEventEmitter=k;function O(U){return new Promise(T=>m(U)(T))}N.toPromise=O})(L=n.Event||(n.Event={}));class v{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${v._idPool++}`}start(m){this._stopWatch=new a.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}v._idPool=0;let u=-1;class g{constructor(m,w=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=w,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let w=u;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||m<w)return;this._stacks||(this._stacks=new Map);const p=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(p)||0;if(this._stacks.set(p,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let i,s=0;for(const[f,d]of this._stacks)(!i||s<d)&&(i=f,s=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(p)||0;this._stacks.set(p,i-1)}}}class C{constructor(m){var w;this._disposed=!1,this._options=m,this._leakageMon=u>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((w=this._options)===null||w===void 0?void 0:w._profName)?new v(this._options._profName):void 0}get event(){return this._event||(this._event=(m,w,p)=>{var r;this._listeners||(this._listeners=new E.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(w?[m,w]:m);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,w);const f=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size),d=(0,R.toDisposable)(()=>{f&&f(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return p instanceof R.DisposableStore?p.add(d):Array.isArray(p)&&p.push(d),d}),this._event}fire(m){var w,p;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,m]);for((w=this._perfMon)===null||w===void 0||w.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,i]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,i):r[0].call(r[1],i)}catch(s){(0,M.onUnexpectedError)(s)}}(p=this._perfMon)===null||p===void 0||p.stop()}}dispose(){var m,w,p,r,i;this._disposed||(this._disposed=!0,(m=this._listeners)===null||m===void 0||m.clear(),(w=this._deliveryQueue)===null||w===void 0||w.clear(),(r=(p=this._options)===null||p===void 0?void 0:p.onLastListenerRemove)===null||r===void 0||r.call(p),(i=this._leakageMon)===null||i===void 0||i.dispose())}}n.Emitter=C;class e extends C{constructor(m){super(m);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=m==null?void 0:m.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}n.PauseableEmitter=e;class o extends e{constructor(m){var w;super(m);this._delay=(w=m.delay)!==null&&w!==void 0?w:100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}n.DebounceEmitter=o;class h{constructor(){this.buffers=[]}wrapEvent(m){return(w,p,r)=>m(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>w.call(p,i)):w.call(p,i)},void 0,r)}bufferEvents(m){const w=[];this.buffers.push(w);const p=m();return this.buffers.pop(),w.forEach(r=>r()),p}}n.EventBufferer=h;class b{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=R.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=b}),$(j[23],G([0,1,7]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const R=Object.freeze(function(v,u){const g=setTimeout(v.bind(u),0);return{dispose(){clearTimeout(g)}}});var E;(function(v){function u(g){return g===v.None||g===v.Cancelled||g instanceof a?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}v.isCancellationToken=u,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(E=n.CancellationToken||(n.CancellationToken={}));class a{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new a),this._token}cancel(){this._token?this._token instanceof a&&this._token.cancel():this._token=E.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof a&&this._token.dispose():this._token=E.None}}n.CancellationTokenSource=L}),$(j[3],G([0,1,2]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.breakBetweenGraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsEmoji=n.containsRTL=n.prevCharLength=n.nextCharLength=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function R(D){return!D||typeof D!="string"?!0:D.trim().length===0}n.isFalsyOrWhitespace=R;const E=/{(\d+)}/g;function a(D,...I){return I.length===0?D:D.replace(E,function(B,q){const z=parseInt(q,10);return isNaN(z)||z<0||z>=I.length?B:I[z]})}n.format=a;function L(D){return D.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}n.escape=L;function v(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=v;function u(D,I=" "){const B=g(D,I);return C(B,I)}n.trim=u;function g(D,I){if(!D||!I)return D;const B=I.length;if(B===0||D.length===0)return D;let q=0;for(;D.indexOf(I,q)===q;)q=q+B;return D.substring(q)}n.ltrim=g;function C(D,I){if(!D||!I)return D;const B=I.length,q=D.length;if(B===0||q===0)return D;let z=q,Q=-1;for(;Q=D.lastIndexOf(I,z-1),!(Q===-1||Q+B!==z);){if(Q===0)return"";z=Q}return D.substring(0,z)}n.rtrim=C;function e(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=e;function o(D){return D.replace(/\*/g,"")}n.stripWildcards=o;function h(D,I,B={}){if(!D)throw new Error("Cannot create regex from empty string");I||(D=v(D)),B.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let q="";return B.global&&(q+="g"),B.matchCase||(q+="i"),B.multiline&&(q+="m"),B.unicode&&(q+="u"),new RegExp(D,q)}n.createRegExp=h;function b(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}n.regExpLeadsToEndlessLoop=b;function N(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}n.regExpFlags=N;function m(D){return D.split(/\r\n|\r|\n/)}n.splitLines=m;function w(D){for(let I=0,B=D.length;I<B;I++){const q=D.charCodeAt(I);if(q!==32&&q!==9)return I}return-1}n.firstNonWhitespaceIndex=w;function p(D,I=0,B=D.length){for(let q=I;q<B;q++){const z=D.charCodeAt(q);if(z!==32&&z!==9)return D.substring(I,q)}return D.substring(I,B)}n.getLeadingWhitespace=p;function r(D,I=D.length-1){for(let B=I;B>=0;B--){const q=D.charCodeAt(B);if(q!==32&&q!==9)return B}return-1}n.lastNonWhitespaceIndex=r;function i(D,I){return D<I?-1:D>I?1:0}n.compare=i;function s(D,I,B=0,q=D.length,z=0,Q=I.length){for(;B<q&&z<Q;B++,z++){let x=D.charCodeAt(B),ne=I.charCodeAt(z);if(x<ne)return-1;if(x>ne)return 1}const J=q-B,K=Q-z;return J<K?-1:J>K?1:0}n.compareSubstring=s;function f(D,I){return d(D,I,0,D.length,0,I.length)}n.compareIgnoreCase=f;function d(D,I,B=0,q=D.length,z=0,Q=I.length){for(;B<q&&z<Q;B++,z++){let x=D.charCodeAt(B),ne=I.charCodeAt(z);if(x===ne)continue;if(x>=128||ne>=128)return s(D.toLowerCase(),I.toLowerCase(),B,q,z,Q);l(x)&&(x-=32),l(ne)&&(ne-=32);const de=x-ne;if(de!==0)return de}const J=q-B,K=Q-z;return J<K?-1:J>K?1:0}n.compareSubstringIgnoreCase=d;function l(D){return D>=97&&D<=122}n.isLowerAsciiLetter=l;function _(D){return D>=65&&D<=90}n.isUpperAsciiLetter=_;function c(D,I){return D.length===I.length&&d(D,I)===0}n.equalsIgnoreCase=c;function S(D,I){const B=I.length;return I.length>D.length?!1:d(D,I,0,B)===0}n.startsWithIgnoreCase=S;function A(D,I){let B,q=Math.min(D.length,I.length);for(B=0;B<q;B++)if(D.charCodeAt(B)!==I.charCodeAt(B))return B;return q}n.commonPrefixLength=A;function y(D,I){let B,q=Math.min(D.length,I.length);const z=D.length-1,Q=I.length-1;for(B=0;B<q;B++)if(D.charCodeAt(z-B)!==I.charCodeAt(Q-B))return B;return q}n.commonSuffixLength=y;function P(D){return 55296<=D&&D<=56319}n.isHighSurrogate=P;function k(D){return 56320<=D&&D<=57343}n.isLowSurrogate=k;function O(D,I){return(D-55296<<10)+(I-56320)+65536}n.computeCodePoint=O;function U(D,I,B){const q=D.charCodeAt(B);if(P(q)&&B+1<I){const z=D.charCodeAt(B+1);if(k(z))return O(q,z)}return q}n.getNextCodePoint=U;function T(D,I){const B=D.charCodeAt(I-1);if(k(B)&&I>1){const q=D.charCodeAt(I-2);if(P(q))return O(q,B)}return B}function H(D,I){const B=ee.getInstance(),q=I,z=D.length,Q=U(D,z,I);I+=Q>=65536?2:1;let J=B.getGraphemeBreakType(Q);for(;I<z;){const K=U(D,z,I),x=B.getGraphemeBreakType(K);if(ce(J,x))break;I+=K>=65536?2:1,J=x}return I-q}n.nextCharLength=H;function W(D,I){const B=ee.getInstance(),q=I,z=T(D,I);I-=z>=65536?2:1;let Q=B.getGraphemeBreakType(z);for(;I>0;){const J=T(D,I),K=B.getGraphemeBreakType(J);if(ce(K,Q))break;I-=J>=65536?2:1,Q=K}return q-I}n.prevCharLength=W;const t=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(D){return t.test(D)}n.containsRTL=V;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function Z(D){return Y.test(D)}n.containsEmoji=Z;const se=/^[\t\n\r\x20-\x7E]*$/;function le(D){return se.test(D)}n.isBasicASCII=le,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(D){return n.UNUSUAL_LINE_TERMINATORS.test(D)}n.containsUnusualLineTerminators=oe;function ae(D){for(let I=0,B=D.length;I<B;I++)if(fe(D.charCodeAt(I)))return!0;return!1}n.containsFullWidthCharacter=ae;function fe(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}n.isFullWidthCharacter=fe;function he(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}n.isEmojiImprecise=he,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}n.startsWithUTF8BOM=_e;function ve(D,I=!1){return D?(I&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}n.containsUppercaseCharacter=ve;function Ce(D){const I=90-65+1;return D=D%(2*I),D<I?String.fromCharCode(97+D):String.fromCharCode(65+D-I)}n.singleLetterHash=Ce;function Le(D){return ee.getInstance().getGraphemeBreakType(D)}n.getGraphemeBreakType=Le;function ce(D,I){return D===0?I!==5&&I!==7:D===2&&I===3?!1:D===4||D===2||D===3||I===4||I===2||I===3?!0:!(D===8&&(I===8||I===9||I===11||I===12)||(D===11||D===9)&&(I===9||I===10)||(D===12||D===10)&&I===10||I===5||I===13||I===7||D===1||D===13&&I===14||D===6&&I===6)}n.breakBetweenGraphemeBreakType=ce;class ee{constructor(){this._data=Se()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const B=this._data,q=B.length/3;let z=1;for(;z<=q;)if(I<B[3*z])z=2*z;else if(I>B[3*z+1])z=2*z+1;else return B[3*z+2];return 0}}ee._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(D,I){if(D===0)return 0;const B=Ne(D,I);if(B!==void 0)return B;const q=T(I,D);return D-=ue(q),D}n.getLeftDeleteOffset=be;function Ne(D,I){let B=T(I,D);for(D-=ue(B);we(B)||B===65039||B===8419;){if(D===0)return;B=T(I,D),D-=ue(B)}if(!!he(B)){if(D>=0){const q=T(I,D);q===8205&&(D-=ue(q))}return D}}function ue(D){return D>=65536?2:1}function we(D){return 127995<=D&&D<=127999}n.noBreakWhitespace="\xA0";class te{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!te.map){let q=function(J){const K=new Map;for(let x=0;x<J.length;x+=2)K.set(J[x],J[x+1]);return K};const I=te.getData();let B=M.locale;(!B||!(B in I))&&(B=M.language),(!B||!(B in I))&&(B="_default");const z=q(I._common),Q=q(I[B]);for(const[J,K]of Q)z.set(J,K);te.map=z}return te.map}static isAmbiguous(I){return te.getConfusablesForCurrentLocale().has(I)}static getPrimaryConfusable(I){return te.getConfusablesForCurrentLocale().get(I)}static getPrimaryConfusableCodePoints(){return new Set(te.getConfusablesForCurrentLocale().keys())}}n.AmbiguousCharacters=te;class re{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(re.getRawData())),this._data}static isInvisibleCharacter(I){return re.getData().has(I)}static get codePoints(){return re.getData()}}n.InvisibleCharacters=re,re._data=void 0}),$(j[24],G([0,1,3]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function R(N){return E(N,0)}n.hash=R;function E(N,m){switch(typeof N){case"object":return N===null?a(349,m):Array.isArray(N)?u(N,m):g(N,m);case"string":return v(N,m);case"boolean":return L(N,m);case"number":return a(N,m);case"undefined":return a(937,m);default:return a(617,m)}}n.doHash=E;function a(N,m){return(m<<5)-m+N|0}n.numberHash=a;function L(N,m){return a(N?433:863,m)}function v(N,m){m=a(149417,m);for(let w=0,p=N.length;w<p;w++)m=a(N.charCodeAt(w),m);return m}n.stringHash=v;function u(N,m){return m=a(104579,m),N.reduce((w,p)=>E(p,w),m)}function g(N,m){return m=a(181387,m),Object.keys(N).sort().reduce((w,p)=>(w=v(p,w),E(N[p],w)),m)}function C(N,m,w=32){const p=w-m,r=~((1<<p)-1);return(N<<m|(r&N)>>>p)>>>0}function e(N,m=0,w=N.byteLength,p=0){for(let r=0;r<w;r++)N[m+r]=p}function o(N,m,w="0"){for(;N.length<m;)N=w+N;return N}function h(N,m=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(w=>w.toString(16).padStart(2,"0")).join(""):o((N>>>0).toString(16),m/4)}n.toHexString=h;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const w=m.length;if(w===0)return;const p=this._buff;let r=this._buffLen,i=this._leftoverHighSurrogate,s,f;for(i!==0?(s=i,f=-1,i=0):(s=m.charCodeAt(0),f=0);;){let d=s;if(M.isHighSurrogate(s))if(f+1<w){const l=m.charCodeAt(f+1);M.isLowSurrogate(l)?(f++,d=M.computeCodePoint(s,l)):d=65533}else{i=s;break}else M.isLowSurrogate(s)&&(d=65533);if(r=this._push(p,r,d),f++,f<w)s=m.charCodeAt(f);else break}this._buffLen=r,this._leftoverHighSurrogate=i}_push(m,w,p){return p<128?m[w++]=p:p<2048?(m[w++]=192|(p&1984)>>>6,m[w++]=128|(p&63)>>>0):p<65536?(m[w++]=224|(p&61440)>>>12,m[w++]=128|(p&4032)>>>6,m[w++]=128|(p&63)>>>0):(m[w++]=240|(p&1835008)>>>18,m[w++]=128|(p&258048)>>>12,m[w++]=128|(p&4032)>>>6,m[w++]=128|(p&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=b._bigBlock32,w=this._buffDV;for(let c=0;c<64;c+=4)m.setUint32(c,w.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)m.setUint32(c,C(m.getUint32(c-12,!1)^m.getUint32(c-32,!1)^m.getUint32(c-56,!1)^m.getUint32(c-64,!1),1),!1);let p=this._h0,r=this._h1,i=this._h2,s=this._h3,f=this._h4,d,l,_;for(let c=0;c<80;c++)c<20?(d=r&i|~r&s,l=1518500249):c<40?(d=r^i^s,l=1859775393):c<60?(d=r&i|r&s|i&s,l=2400959708):(d=r^i^s,l=3395469782),_=C(p,5)+d+f+l+m.getUint32(c*4,!1)&4294967295,f=s,s=i,i=C(r,30),r=p,p=_;this._h0=this._h0+p&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+f&4294967295}}n.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),$(j[11],G([0,1,16,24]),function(F,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class E{constructor(e){this.source=e}getElements(){const e=this.source,o=new Int32Array(e.length);for(let h=0,b=e.length;h<b;h++)o[h]=e.charCodeAt(h);return o}}n.StringDiffSequence=E;function a(C,e,o){return new g(new E(C),new E(e)).ComputeDiff(o).changes}n.stringDiff=a;class L{static Assert(e,o){if(!e)throw new Error(o)}}n.Debug=L;class v{static Copy(e,o,h,b,N){for(let m=0;m<N;m++)h[b+m]=e[o+m]}static Copy2(e,o,h,b,N){for(let m=0;m<N;m++)h[b+m]=e[o+m]}}n.MyArray=v;class u{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,o){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,o),this.m_originalCount++}AddModifiedElement(e,o){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,o),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class g{constructor(e,o,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=e,this._modifiedSequence=o;const[b,N,m]=g._getElements(e),[w,p,r]=g._getElements(o);this._hasStrings=m&&r,this._originalStringElements=b,this._originalElementsOrHash=N,this._modifiedStringElements=w,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const o=e.getElements();if(g._isStringArray(o)){const h=new Int32Array(o.length);for(let b=0,N=o.length;b<N;b++)h[b]=(0,R.stringHash)(o[b],0);return[o,h,!0]}return o instanceof Int32Array?[[],o,!1]:[[],new Int32Array(o),!1]}ElementsAreEqual(e,o){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[o]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[o]:!0}ElementsAreStrictEqual(e,o){if(!this.ElementsAreEqual(e,o))return!1;const h=g._getStrictElement(this._originalSequence,e),b=g._getStrictElement(this._modifiedSequence,o);return h===b}static _getStrictElement(e,o){return typeof e.getStrictElement=="function"?e.getStrictElement(o):null}OriginalElementsAreEqual(e,o){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[o]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[o]:!0}ModifiedElementsAreEqual(e,o){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[o]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[o]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,o,h,b,N){const m=[!1];let w=this.ComputeDiffRecursive(e,o,h,b,m);return N&&(w=this.PrettifyChanges(w)),{quitEarly:m[0],changes:w}}ComputeDiffRecursive(e,o,h,b,N){for(N[0]=!1;e<=o&&h<=b&&this.ElementsAreEqual(e,h);)e++,h++;for(;o>=e&&b>=h&&this.ElementsAreEqual(o,b);)o--,b--;if(e>o||h>b){let s;return h<=b?(L.Assert(e===o+1,"originalStart should only be one more than originalEnd"),s=[new M.DiffChange(e,0,h,b-h+1)]):e<=o?(L.Assert(h===b+1,"modifiedStart should only be one more than modifiedEnd"),s=[new M.DiffChange(e,o-e+1,h,0)]):(L.Assert(e===o+1,"originalStart should only be one more than originalEnd"),L.Assert(h===b+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const m=[0],w=[0],p=this.ComputeRecursionPoint(e,o,h,b,m,w,N),r=m[0],i=w[0];if(p!==null)return p;if(!N[0]){const s=this.ComputeDiffRecursive(e,r,h,i,N);let f=[];return N[0]?f=[new M.DiffChange(r+1,o-(r+1)+1,i+1,b-(i+1)+1)]:f=this.ComputeDiffRecursive(r+1,o,i+1,b,N),this.ConcatenateChanges(s,f)}return[new M.DiffChange(e,o-e+1,h,b-h+1)]}WALKTRACE(e,o,h,b,N,m,w,p,r,i,s,f,d,l,_,c,S,A){let y=null,P=null,k=new u,O=o,U=h,T=d[0]-c[0]-b,H=-1073741824,W=this.m_forwardHistory.length-1;do{const t=T+e;t===O||t<U&&r[t-1]<r[t+1]?(s=r[t+1],l=s-T-b,s<H&&k.MarkNextChange(),H=s,k.AddModifiedElement(s+1,l),T=t+1-e):(s=r[t-1]+1,l=s-T-b,s<H&&k.MarkNextChange(),H=s-1,k.AddOriginalElement(s,l+1),T=t-1-e),W>=0&&(r=this.m_forwardHistory[W],e=r[0],O=1,U=r.length-1)}while(--W>=-1);if(y=k.getReverseChanges(),A[0]){let t=d[0]+1,V=c[0]+1;if(y!==null&&y.length>0){const Y=y[y.length-1];t=Math.max(t,Y.getOriginalEnd()),V=Math.max(V,Y.getModifiedEnd())}P=[new M.DiffChange(t,f-t+1,V,_-V+1)]}else{k=new u,O=m,U=w,T=d[0]-c[0]-p,H=1073741824,W=S?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const t=T+N;t===O||t<U&&i[t-1]>=i[t+1]?(s=i[t+1]-1,l=s-T-p,s>H&&k.MarkNextChange(),H=s+1,k.AddOriginalElement(s+1,l+1),T=t+1-N):(s=i[t-1],l=s-T-p,s>H&&k.MarkNextChange(),H=s,k.AddModifiedElement(s+1,l+1),T=t-1-N),W>=0&&(i=this.m_reverseHistory[W],N=i[0],O=1,U=i.length-1)}while(--W>=-1);P=k.getChanges()}return this.ConcatenateChanges(y,P)}ComputeRecursionPoint(e,o,h,b,N,m,w){let p=0,r=0,i=0,s=0,f=0,d=0;e--,h--,N[0]=0,m[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=o-e+(b-h),_=l+1,c=new Int32Array(_),S=new Int32Array(_),A=b-h,y=o-e,P=e-h,k=o-b,U=(y-A)%2==0;c[A]=e,S[y]=o,w[0]=!1;for(let T=1;T<=l/2+1;T++){let H=0,W=0;i=this.ClipDiagonalBound(A-T,T,A,_),s=this.ClipDiagonalBound(A+T,T,A,_);for(let V=i;V<=s;V+=2){V===i||V<s&&c[V-1]<c[V+1]?p=c[V+1]:p=c[V-1]+1,r=p-(V-A)-P;const Y=p;for(;p<o&&r<b&&this.ElementsAreEqual(p+1,r+1);)p++,r++;if(c[V]=p,p+r>H+W&&(H=p,W=r),!U&&Math.abs(V-y)<=T-1&&p>=S[V])return N[0]=p,m[0]=r,Y<=S[V]&&1447>0&&T<=1447+1?this.WALKTRACE(A,i,s,P,y,f,d,k,c,S,p,o,N,r,b,m,U,w):null}const t=(H-e+(W-h)-T)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,t))return w[0]=!0,N[0]=H,m[0]=W,t>0&&1447>0&&T<=1447+1?this.WALKTRACE(A,i,s,P,y,f,d,k,c,S,p,o,N,r,b,m,U,w):(e++,h++,[new M.DiffChange(e,o-e+1,h,b-h+1)]);f=this.ClipDiagonalBound(y-T,T,y,_),d=this.ClipDiagonalBound(y+T,T,y,_);for(let V=f;V<=d;V+=2){V===f||V<d&&S[V-1]>=S[V+1]?p=S[V+1]-1:p=S[V-1],r=p-(V-y)-k;const Y=p;for(;p>e&&r>h&&this.ElementsAreEqual(p,r);)p--,r--;if(S[V]=p,U&&Math.abs(V-A)<=T&&p<=c[V])return N[0]=p,m[0]=r,Y>=c[V]&&1447>0&&T<=1447+1?this.WALKTRACE(A,i,s,P,y,f,d,k,c,S,p,o,N,r,b,m,U,w):null}if(T<=1447){let V=new Int32Array(s-i+2);V[0]=A-i+1,v.Copy2(c,i,V,1,s-i+1),this.m_forwardHistory.push(V),V=new Int32Array(d-f+2),V[0]=y-f+1,v.Copy2(S,f,V,1,d-f+1),this.m_reverseHistory.push(V)}}return this.WALKTRACE(A,i,s,P,y,f,d,k,c,S,p,o,N,r,b,m,U,w)}PrettifyChanges(e){for(let o=0;o<e.length;o++){const h=e[o],b=o<e.length-1?e[o+1].originalStart:this._originalElementsOrHash.length,N=o<e.length-1?e[o+1].modifiedStart:this._modifiedElementsOrHash.length,m=h.originalLength>0,w=h.modifiedLength>0;for(;h.originalStart+h.originalLength<b&&h.modifiedStart+h.modifiedLength<N&&(!m||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!w||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const r=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!r)break;h.originalStart++,h.modifiedStart++}let p=[null];if(o<e.length-1&&this.ChangesOverlap(e[o],e[o+1],p)){e[o]=p[0],e.splice(o+1,1),o--;continue}}for(let o=e.length-1;o>=0;o--){const h=e[o];let b=0,N=0;if(o>0){const s=e[o-1];b=s.originalStart+s.originalLength,N=s.modifiedStart+s.modifiedLength}const m=h.originalLength>0,w=h.modifiedLength>0;let p=0,r=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let s=1;;s++){const f=h.originalStart-s,d=h.modifiedStart-s;if(f<b||d<N||m&&!this.OriginalElementsAreEqual(f,f+h.originalLength)||w&&!this.ModifiedElementsAreEqual(d,d+h.modifiedLength))break;const _=(f===b&&d===N?5:0)+this._boundaryScore(f,h.originalLength,d,h.modifiedLength);_>r&&(r=_,p=s)}h.originalStart-=p,h.modifiedStart-=p;const i=[null];if(o>0&&this.ChangesOverlap(e[o-1],e[o],i)){e[o-1]=i[0],e.splice(o,1),o++;continue}}if(this._hasStrings)for(let o=1,h=e.length;o<h;o++){const b=e[o-1],N=e[o],m=N.originalStart-b.originalStart-b.originalLength,w=b.originalStart,p=N.originalStart+N.originalLength,r=p-w,i=b.modifiedStart,s=N.modifiedStart+N.modifiedLength,f=s-i;if(m<5&&r<20&&f<20){const d=this._findBetterContiguousSequence(w,r,i,f,m);if(d){const[l,_]=d;(l!==b.originalStart+b.originalLength||_!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=l-b.originalStart,b.modifiedLength=_-b.modifiedStart,N.originalStart=l+m,N.modifiedStart=_+m,N.originalLength=p-N.originalStart,N.modifiedLength=s-N.modifiedStart)}}}return e}_findBetterContiguousSequence(e,o,h,b,N){if(o<N||b<N)return null;const m=e+o-N+1,w=h+b-N+1;let p=0,r=0,i=0;for(let s=e;s<m;s++)for(let f=h;f<w;f++){const d=this._contiguousSequenceScore(s,f,N);d>0&&d>p&&(p=d,r=s,i=f)}return p>0?[r,i]:null}_contiguousSequenceScore(e,o,h){let b=0;for(let N=0;N<h;N++){if(!this.ElementsAreEqual(e+N,o+N))return 0;b+=this._originalStringElements[e+N].length}return b}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,o){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(o>0){const h=e+o;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,o){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(o>0){const h=e+o;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(e,o,h,b){const N=this._OriginalRegionIsBoundary(e,o)?1:0,m=this._ModifiedRegionIsBoundary(h,b)?1:0;return N+m}ConcatenateChanges(e,o){let h=[];if(e.length===0||o.length===0)return o.length>0?o:e;if(this.ChangesOverlap(e[e.length-1],o[0],h)){const b=new Array(e.length+o.length-1);return v.Copy(e,0,b,0,e.length-1),b[e.length-1]=h[0],v.Copy(o,1,b,e.length,o.length-1),b}else{const b=new Array(e.length+o.length);return v.Copy(e,0,b,0,e.length),v.Copy(o,0,b,e.length,o.length),b}}ChangesOverlap(e,o,h){if(L.Assert(e.originalStart<=o.originalStart,"Left change is not less than or equal to right change"),L.Assert(e.modifiedStart<=o.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=o.originalStart||e.modifiedStart+e.modifiedLength>=o.modifiedStart){const b=e.originalStart;let N=e.originalLength;const m=e.modifiedStart;let w=e.modifiedLength;return e.originalStart+e.originalLength>=o.originalStart&&(N=o.originalStart+o.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=o.modifiedStart&&(w=o.modifiedStart+o.modifiedLength-e.modifiedStart),h[0]=new M.DiffChange(b,N,m,w),!0}else return h[0]=null,!1}ClipDiagonalBound(e,o,h,b){if(e>=0&&e<b)return e;const N=h,m=b-h-1,w=o%2==0;if(e<0){const p=N%2==0;return w===p?0:1}else{const p=m%2==0;return w===p?b-1:b-2}}}n.LcsDiff=g}),$(j[6],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isNumber=n.isObject=n.isString=n.isArray=void 0;function M(i){return Array.isArray(i)}n.isArray=M;function R(i){return typeof i=="string"}n.isString=R;function E(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}n.isObject=E;function a(i){return typeof i=="number"&&!isNaN(i)}n.isNumber=a;function L(i){return i===!0||i===!1}n.isBoolean=L;function v(i){return typeof i=="undefined"}n.isUndefined=v;function u(i){return!g(i)}n.isDefined=u;function g(i){return v(i)||i===null}n.isUndefinedOrNull=g;function C(i,s){if(!i)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}n.assertType=C;function e(i){if(g(i))throw new Error("Assertion Failed: argument is undefined or null");return i}n.assertIsDefined=e;function o(i){return typeof i=="function"}n.isFunction=o;function h(i,s){const f=Math.min(i.length,s.length);for(let d=0;d<f;d++)b(i[d],s[d])}n.validateConstraints=h;function b(i,s){if(R(s)){if(typeof i!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(o(s)){try{if(i instanceof s)return}catch(f){}if(!g(i)&&i.constructor===s||s.length===1&&s.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b;function N(i){let s=[],f=Object.getPrototypeOf(i);for(;Object.prototype!==f;)s=s.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return s}n.getAllPropertyNames=N;function m(i){const s=[];for(const f of N(i))typeof i[f]=="function"&&s.push(f);return s}n.getAllMethodNames=m;function w(i,s){const f=l=>function(){const _=Array.prototype.slice.call(arguments,0);return s(l,_)};let d={};for(const l of i)d[l]=f(l);return d}n.createProxyObject=w;function p(i){return i===null?void 0:i}n.withNullAsUndefined=p;function r(i,s="Unreachable"){throw new Error(s)}n.assertNever=r}),$(j[25],G([0,1,6]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getOrDefault=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function R(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const o=Array.isArray(e)?[]:{};return Object.keys(e).forEach(h=>{e[h]&&typeof e[h]=="object"?o[h]=R(e[h]):o[h]=e[h]}),o}n.deepClone=R;function E(e){if(!e||typeof e!="object")return e;const o=[e];for(;o.length>0;){const h=o.shift();Object.freeze(h);for(const b in h)if(a.call(h,b)){const N=h[b];typeof N=="object"&&!Object.isFrozen(N)&&o.push(N)}}return e}n.deepFreeze=E;const a=Object.prototype.hasOwnProperty;function L(e,o){return v(e,o,new Set)}n.cloneAndChange=L;function v(e,o,h){if((0,M.isUndefinedOrNull)(e))return e;const b=o(e);if(typeof b!="undefined")return b;if((0,M.isArray)(e)){const N=[];for(const m of e)N.push(v(m,o,h));return N}if((0,M.isObject)(e)){if(h.has(e))throw new Error("Cannot clone recursive data-structure");h.add(e);const N={};for(let m in e)a.call(e,m)&&(N[m]=v(e[m],o,h));return h.delete(e),N}return e}function u(e,o,h=!0){return(0,M.isObject)(e)?((0,M.isObject)(o)&&Object.keys(o).forEach(b=>{b in e?h&&((0,M.isObject)(e[b])&&(0,M.isObject)(o[b])?u(e[b],o[b],h):e[b]=o[b]):e[b]=o[b]}),e):o}n.mixin=u;function g(e,o){if(e===o)return!0;if(e==null||o===null||o===void 0||typeof e!=typeof o||typeof e!="object"||Array.isArray(e)!==Array.isArray(o))return!1;let h,b;if(Array.isArray(e)){if(e.length!==o.length)return!1;for(h=0;h<e.length;h++)if(!g(e[h],o[h]))return!1}else{const N=[];for(b in e)N.push(b);N.sort();const m=[];for(b in o)m.push(b);if(m.sort(),!g(N,m))return!1;for(h=0;h<N.length;h++)if(!g(e[N[h]],o[N[h]]))return!1}return!0}n.equals=g;function C(e,o,h){const b=o(e);return typeof b=="undefined"?h:b}n.getOrDefault=C}),$(j[12],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function M(E){return E<0?0:E>255?255:E|0}n.toUint8=M;function R(E){return E<0?0:E>4294967295?4294967295:E|0}n.toUint32=R}),$(j[13],G([0,1,22,2]),function(F,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const E=/^\w[\w\d+.-]*$/,a=/^\//,L=/^\/\//;function v(l,_){if(!l.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!E.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!a.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(l,_){return!l&&!_?"file":l}function g(l,_){switch(l){case"https":case"http":case"file":_?_[0]!==e&&(_=e+_):_=e;break}return _}const C="",e="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(_,c,S,A,y,P=!1){typeof _=="object"?(this.scheme=_.scheme||C,this.authority=_.authority||C,this.path=_.path||C,this.query=_.query||C,this.fragment=_.fragment||C):(this.scheme=u(_,P),this.authority=c||C,this.path=g(this.scheme,S||C),this.query=A||C,this.fragment=y||C,v(this,P))}static isUri(_){return _ instanceof h?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}get fsPath(){return r(this,!1)}with(_){if(!_)return this;let{scheme:c,authority:S,path:A,query:y,fragment:P}=_;return c===void 0?c=this.scheme:c===null&&(c=C),S===void 0?S=this.authority:S===null&&(S=C),A===void 0?A=this.path:A===null&&(A=C),y===void 0?y=this.query:y===null&&(y=C),P===void 0?P=this.fragment:P===null&&(P=C),c===this.scheme&&S===this.authority&&A===this.path&&y===this.query&&P===this.fragment?this:new N(c,S,A,y,P)}static parse(_,c=!1){const S=o.exec(_);return S?new N(S[2]||C,d(S[4]||C),d(S[5]||C),d(S[7]||C),d(S[9]||C),c):new N(C,C,C,C,C)}static file(_){let c=C;if(R.isWindows&&(_=_.replace(/\\/g,e)),_[0]===e&&_[1]===e){const S=_.indexOf(e,2);S===-1?(c=_.substring(2),_=e):(c=_.substring(2,S),_=_.substring(S)||e)}return new N("file",c,_,C,C)}static from(_){const c=new N(_.scheme,_.authority,_.path,_.query,_.fragment);return v(c,!0),c}static joinPath(_,...c){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return R.isWindows&&_.scheme==="file"?S=h.file(M.win32.join(r(_,!0),...c)).path:S=M.posix.join(_.path,...c),_.with({path:S})}toString(_=!1){return i(this,_)}toJSON(){return this}static revive(_){if(_){if(_ instanceof h)return _;{const c=new N(_);return c._formatted=_.external,c._fsPath=_._sep===b?_.fsPath:null,c}}else return _}}n.URI=h;const b=R.isWindows?1:void 0;class N extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(_=!1){return _?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const _={$mid:1};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=b),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(l,_){let c,S=-1;for(let A=0;A<l.length;A++){const y=l.charCodeAt(A);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||_&&y===47)S!==-1&&(c+=encodeURIComponent(l.substring(S,A)),S=-1),c!==void 0&&(c+=l.charAt(A));else{c===void 0&&(c=l.substr(0,A));const P=m[y];P!==void 0?(S!==-1&&(c+=encodeURIComponent(l.substring(S,A)),S=-1),c+=P):S===-1&&(S=A)}}return S!==-1&&(c+=encodeURIComponent(l.substring(S))),c!==void 0?c:l}function p(l){let _;for(let c=0;c<l.length;c++){const S=l.charCodeAt(c);S===35||S===63?(_===void 0&&(_=l.substr(0,c)),_+=m[S]):_!==void 0&&(_+=l[c])}return _!==void 0?_:l}function r(l,_){let c;return l.authority&&l.path.length>1&&l.scheme==="file"?c=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?_?c=l.path.substr(1):c=l.path[1].toLowerCase()+l.path.substr(2):c=l.path,R.isWindows&&(c=c.replace(/\//g,"\\")),c}n.uriToFsPath=r;function i(l,_){const c=_?p:w;let S="",{scheme:A,authority:y,path:P,query:k,fragment:O}=l;if(A&&(S+=A,S+=":"),(y||A==="file")&&(S+=e,S+=e),y){let U=y.indexOf("@");if(U!==-1){const T=y.substr(0,U);y=y.substr(U+1),U=T.indexOf(":"),U===-1?S+=c(T,!1):(S+=c(T.substr(0,U),!1),S+=":",S+=c(T.substr(U+1),!1)),S+="@"}y=y.toLowerCase(),U=y.indexOf(":"),U===-1?S+=c(y,!1):(S+=c(y.substr(0,U),!1),S+=y.substr(U))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const U=P.charCodeAt(1);U>=65&&U<=90&&(P=`/${String.fromCharCode(U+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const U=P.charCodeAt(0);U>=65&&U<=90&&(P=`${String.fromCharCode(U+32)}:${P.substr(2)}`)}S+=c(P,!0)}return k&&(S+="?",S+=c(k,!1)),O&&(S+="#",S+=_?O:w(O,!1)),S}function s(l){try{return decodeURIComponent(l)}catch(_){return l.length>3?l.substr(0,3)+s(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,_=>s(_)):l}}),$(j[40],G([0,1,8,7,9,2,6,3]),function(F,n,M,R,E,a,L,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const u="$initialize";let g=!1;function C(d){!a.isWeb||(g||(g=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}n.logOnceWebWorkerWarning=C;class e{constructor(l,_,c,S){this.vsWorker=l,this.req=_,this.method=c,this.args=S,this.type=0}}class o{constructor(l,_,c,S){this.vsWorker=l,this.seq=_,this.res=c,this.err=S,this.type=1}}class h{constructor(l,_,c,S){this.vsWorker=l,this.req=_,this.eventName=c,this.arg=S,this.type=2}}class b{constructor(l,_,c){this.vsWorker=l,this.req=_,this.event=c,this.type=3}}class N{constructor(l,_){this.vsWorker=l,this.req=_,this.type=4}}class m{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,_){const c=String(++this._lastSentReq);return new Promise((S,A)=>{this._pendingReplies[c]={resolve:S,reject:A},this._send(new e(this._workerId,c,l,_))})}listen(l,_){let c=null;const S=new R.Emitter({onFirstListenerAdd:()=>{c=String(++this._lastSentReq),this._pendingEmitters.set(c,S),this._send(new h(this._workerId,c,l,_))},onLastListenerRemove:()=>{this._pendingEmitters.delete(c),this._send(new N(this._workerId,c)),c=null}});return S.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}let _=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let c=l.err;l.err.$isError&&(c=new Error,c.name=l.err.name,c.message=l.err.message,c.stack=l.err.stack),_.reject(c);return}_.resolve(l.res)}_handleRequestMessage(l){let _=l.req;this._handler.handleMessage(l.method,l.args).then(S=>{this._send(new o(this._workerId,_,S,void 0))},S=>{S.detail instanceof Error&&(S.detail=(0,M.transformErrorForSerialization)(S.detail)),this._send(new o(this._workerId,_,void 0,(0,M.transformErrorForSerialization)(S)))})}_handleSubscribeEventMessage(l){const _=l.req,c=this._handler.handleEvent(l.eventName,l.arg)(S=>{this._send(new b(this._workerId,_,S))});this._pendingEvents.set(_,c)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){let _=[];if(l.type===0)for(let c=0;c<l.args.length;c++)l.args[c]instanceof ArrayBuffer&&_.push(l.args[c]);else l.type===1&&l.res instanceof ArrayBuffer&&_.push(l.res);this._handler.sendMessage(l,_)}}class w extends E.Disposable{constructor(l,_,c){super();let S=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{S&&S(O)})),this._protocol=new m({sendMessage:(O,U)=>{this._worker.postMessage(O,U)},handleMessage:(O,U)=>{if(typeof c[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(c[O].apply(c,U))}catch(T){return Promise.reject(T)}},handleEvent:(O,U)=>{if(r(O)){const T=c[O].call(c,U);if(typeof T!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return T}if(p(O)){const T=c[O];if(typeof T!="function")throw new Error(`Missing event ${O} on main thread host.`);return T}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let A=null;typeof a.globals.require!="undefined"&&typeof a.globals.require.getConfig=="function"?A=a.globals.require.getConfig():typeof a.globals.requirejs!="undefined"&&(A=a.globals.requirejs.s.contexts._.config);const y=L.getAllMethodNames(c);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(A)),_,y]);const P=(O,U)=>this._request(O,U),k=(O,U)=>this._protocol.listen(O,U);this._lazyProxy=new Promise((O,U)=>{S=U,this._onModuleLoaded.then(T=>{O(i(T,P,k))},T=>{U(T),this._onError("Worker failed to load "+_,T)})})}getProxyObject(){return this._lazyProxy}_request(l,_){return new Promise((c,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,_).then(c,S)},S)})}_onError(l,_){console.error(l),console.info(_)}}n.SimpleWorkerClient=w;function p(d){return d[0]==="o"&&d[1]==="n"&&v.isUpperAsciiLetter(d.charCodeAt(2))}function r(d){return/^onDynamic/.test(d)&&v.isUpperAsciiLetter(d.charCodeAt(9))}function i(d,l,_){const c=y=>function(){const P=Array.prototype.slice.call(arguments,0);return l(y,P)},S=y=>function(P){return _(y,P)};let A={};for(const y of d){if(r(y)){A[y]=S(y);continue}if(p(y)){A[y]=_(y,void 0);continue}A[y]=c(y)}return A}class s{constructor(l,_){this._requestHandlerFactory=_,this._requestHandler=null,this._protocol=new m({sendMessage:(c,S)=>{l(c,S)},handleMessage:(c,S)=>this._handleMessage(c,S),handleEvent:(c,S)=>this._handleEvent(c,S)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,_){if(l===u)return this.initialize(_[0],_[1],_[2],_[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,_))}catch(c){return Promise.reject(c)}}_handleEvent(l,_){if(!this._requestHandler)throw new Error("Missing requestHandler");if(r(l)){const c=this._requestHandler[l].call(this._requestHandler,_);if(typeof c!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return c}if(p(l)){const c=this._requestHandler[l];if(typeof c!="function")throw new Error(`Missing event ${l} on request handler.`);return c}throw new Error(`Malformed event name ${l}`)}initialize(l,_,c,S){this._protocol.setWorkerId(l);const P=i(S,(k,O)=>this._protocol.sendMessage(k,O),(k,O)=>this._protocol.listen(k,O));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve(L.getAllMethodNames(this._requestHandler))):(_&&(typeof _.baseUrl!="undefined"&&delete _.baseUrl,typeof _.paths!="undefined"&&typeof _.paths.vs!="undefined"&&delete _.paths.vs,typeof _.trustedTypesPolicy!==void 0&&delete _.trustedTypesPolicy,_.catchError=!0,a.globals.require.config(_)),new Promise((k,O)=>{(a.globals.require||F)([c],T=>{if(this._requestHandler=T.create(P),!this._requestHandler){O(new Error("No RequestHandler!"));return}k(L.getAllMethodNames(this._requestHandler))},O)}))}}n.SimpleWorkerServer=s;function f(d){return new s(d,null)}n.create=f}),$(j[14],G([0,1,12]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class R{constructor(L){let v=(0,M.toUint8)(L);this._defaultValue=v,this._asciiMap=R._createAsciiMap(v),this._map=new Map}static _createAsciiMap(L){let v=new Uint8Array(256);for(let u=0;u<256;u++)v[u]=L;return v}set(L,v){let u=(0,M.toUint8)(v);L>=0&&L<256?this._asciiMap[L]=u:this._map.set(L,u)}get(L){return L>=0&&L<256?this._asciiMap[L]:this._map.get(L)||this._defaultValue}}n.CharacterClassifier=R;class E{constructor(){this._actual=new R(0)}add(L){this._actual.set(L,1)}has(L){return this._actual.get(L)===1}}n.CharacterSet=E}),$(j[26],G([0,1,14]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class R extends M.CharacterClassifier{constructor(L){super(0);for(let v=0,u=L.length;v<u;v++)this.set(L.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=R;function E(a){let L={};return v=>(L.hasOwnProperty(v)||(L[v]=a(v)),L[v])}n.getMapForWordSeparators=E(a=>new R(a))}),$(j[4],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class M{constructor(E,a){this.lineNumber=E,this.column=a}with(E=this.lineNumber,a=this.column){return E===this.lineNumber&&a===this.column?this:new M(E,a)}delta(E=0,a=0){return this.with(this.lineNumber+E,this.column+a)}equals(E){return M.equals(this,E)}static equals(E,a){return!E&&!a?!0:!!E&&!!a&&E.lineNumber===a.lineNumber&&E.column===a.column}isBefore(E){return M.isBefore(this,E)}static isBefore(E,a){return E.lineNumber<a.lineNumber?!0:a.lineNumber<E.lineNumber?!1:E.column<a.column}isBeforeOrEqual(E){return M.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,a){return E.lineNumber<a.lineNumber?!0:a.lineNumber<E.lineNumber?!1:E.column<=a.column}static compare(E,a){let L=E.lineNumber|0,v=a.lineNumber|0;if(L===v){let u=E.column|0,g=a.column|0;return u-g}return L-v}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new M(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}}n.Position=M}),$(j[5],G([0,1,4]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class R{constructor(a,L,v,u){a>v||a===v&&L>u?(this.startLineNumber=v,this.startColumn=u,this.endLineNumber=a,this.endColumn=L):(this.startLineNumber=a,this.startColumn=L,this.endLineNumber=v,this.endColumn=u)}isEmpty(){return R.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return R.containsPosition(this,a)}static containsPosition(a,L){return!(L.lineNumber<a.startLineNumber||L.lineNumber>a.endLineNumber||L.lineNumber===a.startLineNumber&&L.column<a.startColumn||L.lineNumber===a.endLineNumber&&L.column>a.endColumn)}static strictContainsPosition(a,L){return!(L.lineNumber<a.startLineNumber||L.lineNumber>a.endLineNumber||L.lineNumber===a.startLineNumber&&L.column<=a.startColumn||L.lineNumber===a.endLineNumber&&L.column>=a.endColumn)}containsRange(a){return R.containsRange(this,a)}static containsRange(a,L){return!(L.startLineNumber<a.startLineNumber||L.endLineNumber<a.startLineNumber||L.startLineNumber>a.endLineNumber||L.endLineNumber>a.endLineNumber||L.startLineNumber===a.startLineNumber&&L.startColumn<a.startColumn||L.endLineNumber===a.endLineNumber&&L.endColumn>a.endColumn)}strictContainsRange(a){return R.strictContainsRange(this,a)}static strictContainsRange(a,L){return!(L.startLineNumber<a.startLineNumber||L.endLineNumber<a.startLineNumber||L.startLineNumber>a.endLineNumber||L.endLineNumber>a.endLineNumber||L.startLineNumber===a.startLineNumber&&L.startColumn<=a.startColumn||L.endLineNumber===a.endLineNumber&&L.endColumn>=a.endColumn)}plusRange(a){return R.plusRange(this,a)}static plusRange(a,L){let v,u,g,C;return L.startLineNumber<a.startLineNumber?(v=L.startLineNumber,u=L.startColumn):L.startLineNumber===a.startLineNumber?(v=L.startLineNumber,u=Math.min(L.startColumn,a.startColumn)):(v=a.startLineNumber,u=a.startColumn),L.endLineNumber>a.endLineNumber?(g=L.endLineNumber,C=L.endColumn):L.endLineNumber===a.endLineNumber?(g=L.endLineNumber,C=Math.max(L.endColumn,a.endColumn)):(g=a.endLineNumber,C=a.endColumn),new R(v,u,g,C)}intersectRanges(a){return R.intersectRanges(this,a)}static intersectRanges(a,L){let v=a.startLineNumber,u=a.startColumn,g=a.endLineNumber,C=a.endColumn,e=L.startLineNumber,o=L.startColumn,h=L.endLineNumber,b=L.endColumn;return v<e?(v=e,u=o):v===e&&(u=Math.max(u,o)),g>h?(g=h,C=b):g===h&&(C=Math.min(C,b)),v>g||v===g&&u>C?null:new R(v,u,g,C)}equalsRange(a){return R.equalsRange(this,a)}static equalsRange(a,L){return!!a&&!!L&&a.startLineNumber===L.startLineNumber&&a.startColumn===L.startColumn&&a.endLineNumber===L.endLineNumber&&a.endColumn===L.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(a){return new M.Position(a.endLineNumber,a.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(a){return new M.Position(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,L){return new R(this.startLineNumber,this.startColumn,a,L)}setStartPosition(a,L){return new R(a,L,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(a){return new R(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}static fromPositions(a,L=a){return new R(a.lineNumber,a.column,L.lineNumber,L.column)}static lift(a){return a?new R(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,L){return!(a.endLineNumber<L.startLineNumber||a.endLineNumber===L.startLineNumber&&a.endColumn<L.startColumn||L.endLineNumber<a.startLineNumber||L.endLineNumber===a.startLineNumber&&L.endColumn<a.startColumn)}static areIntersecting(a,L){return!(a.endLineNumber<L.startLineNumber||a.endLineNumber===L.startLineNumber&&a.endColumn<=L.startColumn||L.endLineNumber<a.startLineNumber||L.endLineNumber===a.startLineNumber&&L.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,L){if(a&&L){const g=a.startLineNumber|0,C=L.startLineNumber|0;if(g===C){const e=a.startColumn|0,o=L.startColumn|0;if(e===o){const h=a.endLineNumber|0,b=L.endLineNumber|0;if(h===b){const N=a.endColumn|0,m=L.endColumn|0;return N-m}return h-b}return e-o}return g-C}return(a?1:0)-(L?1:0)}static compareRangesUsingEnds(a,L){return a.endLineNumber===L.endLineNumber?a.endColumn===L.endColumn?a.startLineNumber===L.startLineNumber?a.startColumn-L.startColumn:a.startLineNumber-L.startLineNumber:a.endColumn-L.endColumn:a.endLineNumber-L.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}}n.Range=R}),$(j[27],G([0,1,4,5]),function(F,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class E extends R.Range{constructor(L,v,u,g){super(L,v,u,g);this.selectionStartLineNumber=L,this.selectionStartColumn=v,this.positionLineNumber=u,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(L){return E.selectionsEqual(this,L)}static selectionsEqual(L,v){return L.selectionStartLineNumber===v.selectionStartLineNumber&&L.selectionStartColumn===v.selectionStartColumn&&L.positionLineNumber===v.positionLineNumber&&L.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(L,v){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,L,v):new E(L,v,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(L,v){return this.getDirection()===0?new E(L,v,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,L,v)}static fromPositions(L,v=L){return new E(L.lineNumber,L.column,v.lineNumber,v.column)}static fromRange(L,v){return v===0?new E(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):new E(L.endLineNumber,L.endColumn,L.startLineNumber,L.startColumn)}static liftSelection(L){return new E(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)}static selectionsArrEqual(L,v){if(L&&!v||!L&&v)return!1;if(!L&&!v)return!0;if(L.length!==v.length)return!1;for(let u=0,g=L.length;u<g;u++)if(!this.selectionsEqual(L[u],v[u]))return!1;return!0}static isISelection(L){return L&&typeof L.selectionStartLineNumber=="number"&&typeof L.selectionStartColumn=="number"&&typeof L.positionLineNumber=="number"&&typeof L.positionColumn=="number"}static createWithDirection(L,v,u,g,C){return C===0?new E(L,v,u,g):new E(u,g,L,v)}}n.Selection=E}),$(j[28],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationResult2=n.TokenizationResult=n.Token=void 0;class M{constructor(L,v,u){this._tokenBrand=void 0,this.offset=L,this.type=v,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=M;class R{constructor(L,v){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=v}}n.TokenizationResult=R;class E{constructor(L,v){this._tokenizationResult2Brand=void 0,this.tokens=L,this.endState=v}}n.TokenizationResult2=E}),$(j[29],G([0,1,11,3]),function(F,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const E=3;function a(N,m,w,p){return new M.LcsDiff(N,m,w).ComputeDiff(p)}class L{constructor(m){const w=[],p=[];for(let r=0,i=m.length;r<i;r++)w[r]=o(m[r],1),p[r]=h(m[r],1);this.lines=m,this._startColumns=w,this._endColumns=p}getElements(){const m=[];for(let w=0,p=this.lines.length;w<p;w++)m[w]=this.lines[w].substring(this._startColumns[w]-1,this._endColumns[w]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,w,p){const r=[],i=[],s=[];let f=0;for(let d=w;d<=p;d++){const l=this.lines[d],_=m?this._startColumns[d]:1,c=m?this._endColumns[d]:l.length+1;for(let S=_;S<c;S++)r[f]=l.charCodeAt(S-1),i[f]=d+1,s[f]=S,f++}return new v(r,i,s)}}class v{constructor(m,w,p){this._charCodes=m,this._lineNumbers=w,this._columns=p}getElements(){return this._charCodes}getStartLineNumber(m){return this._lineNumbers[m]}getStartColumn(m){return this._columns[m]}getEndLineNumber(m){return this._lineNumbers[m]}getEndColumn(m){return this._columns[m]+1}}class u{constructor(m,w,p,r,i,s,f,d){this.originalStartLineNumber=m,this.originalStartColumn=w,this.originalEndLineNumber=p,this.originalEndColumn=r,this.modifiedStartLineNumber=i,this.modifiedStartColumn=s,this.modifiedEndLineNumber=f,this.modifiedEndColumn=d}static createFromDiffChange(m,w,p){let r,i,s,f,d,l,_,c;return m.originalLength===0?(r=0,i=0,s=0,f=0):(r=w.getStartLineNumber(m.originalStart),i=w.getStartColumn(m.originalStart),s=w.getEndLineNumber(m.originalStart+m.originalLength-1),f=w.getEndColumn(m.originalStart+m.originalLength-1)),m.modifiedLength===0?(d=0,l=0,_=0,c=0):(d=p.getStartLineNumber(m.modifiedStart),l=p.getStartColumn(m.modifiedStart),_=p.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),c=p.getEndColumn(m.modifiedStart+m.modifiedLength-1)),new u(r,i,s,f,d,l,_,c)}}function g(N){if(N.length<=1)return N;const m=[N[0]];let w=m[0];for(let p=1,r=N.length;p<r;p++){const i=N[p],s=i.originalStart-(w.originalStart+w.originalLength),f=i.modifiedStart-(w.modifiedStart+w.modifiedLength);Math.min(s,f)<E?(w.originalLength=i.originalStart+i.originalLength-w.originalStart,w.modifiedLength=i.modifiedStart+i.modifiedLength-w.modifiedStart):(m.push(i),w=i)}return m}class C{constructor(m,w,p,r,i){this.originalStartLineNumber=m,this.originalEndLineNumber=w,this.modifiedStartLineNumber=p,this.modifiedEndLineNumber=r,this.charChanges=i}static createFromDiffResult(m,w,p,r,i,s,f){let d,l,_,c,S;if(w.originalLength===0?(d=p.getStartLineNumber(w.originalStart)-1,l=0):(d=p.getStartLineNumber(w.originalStart),l=p.getEndLineNumber(w.originalStart+w.originalLength-1)),w.modifiedLength===0?(_=r.getStartLineNumber(w.modifiedStart)-1,c=0):(_=r.getStartLineNumber(w.modifiedStart),c=r.getEndLineNumber(w.modifiedStart+w.modifiedLength-1)),s&&w.originalLength>0&&w.originalLength<20&&w.modifiedLength>0&&w.modifiedLength<20&&i()){const A=p.createCharSequence(m,w.originalStart,w.originalStart+w.originalLength-1),y=r.createCharSequence(m,w.modifiedStart,w.modifiedStart+w.modifiedLength-1);let P=a(A,y,i,!0).changes;f&&(P=g(P)),S=[];for(let k=0,O=P.length;k<O;k++)S.push(u.createFromDiffChange(P[k],A,y))}return new C(d,l,_,c,S)}}class e{constructor(m,w,p){this.shouldComputeCharChanges=p.shouldComputeCharChanges,this.shouldPostProcessCharChanges=p.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=p.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=p.shouldMakePrettyDiff,this.originalLines=m,this.modifiedLines=w,this.original=new L(m),this.modified=new L(w),this.continueLineDiff=b(p.maxComputationTime),this.continueCharDiff=b(p.maxComputationTime===0?0:Math.min(p.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const m=a(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),w=m.changes,p=m.quitEarly;if(this.shouldIgnoreTrimWhitespace){const f=[];for(let d=0,l=w.length;d<l;d++)f.push(C.createFromDiffResult(this.shouldIgnoreTrimWhitespace,w[d],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:p,changes:f}}const r=[];let i=0,s=0;for(let f=-1,d=w.length;f<d;f++){const l=f+1<d?w[f+1]:null,_=l?l.originalStart:this.originalLines.length,c=l?l.modifiedStart:this.modifiedLines.length;for(;i<_&&s<c;){const S=this.originalLines[i],A=this.modifiedLines[s];if(S!==A){{let y=o(S,1),P=o(A,1);for(;y>1&&P>1;){const k=S.charCodeAt(y-2),O=A.charCodeAt(P-2);if(k!==O)break;y--,P--}(y>1||P>1)&&this._pushTrimWhitespaceCharChange(r,i+1,1,y,s+1,1,P)}{let y=h(S,1),P=h(A,1);const k=S.length+1,O=A.length+1;for(;y<k&&P<O;){const U=S.charCodeAt(y-1),T=S.charCodeAt(P-1);if(U!==T)break;y++,P++}(y<k||P<O)&&this._pushTrimWhitespaceCharChange(r,i+1,y,k,s+1,P,O)}}i++,s++}l&&(r.push(C.createFromDiffResult(this.shouldIgnoreTrimWhitespace,l,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=l.originalLength,s+=l.modifiedLength)}return{quitEarly:p,changes:r}}_pushTrimWhitespaceCharChange(m,w,p,r,i,s,f){if(this._mergeTrimWhitespaceCharChange(m,w,p,r,i,s,f))return;let d;this.shouldComputeCharChanges&&(d=[new u(w,p,w,r,i,s,i,f)]),m.push(new C(w,w,i,i,d))}_mergeTrimWhitespaceCharChange(m,w,p,r,i,s,f){const d=m.length;if(d===0)return!1;const l=m[d-1];return l.originalEndLineNumber===0||l.modifiedEndLineNumber===0?!1:l.originalEndLineNumber+1===w&&l.modifiedEndLineNumber+1===i?(l.originalEndLineNumber=w,l.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&l.charChanges&&l.charChanges.push(new u(w,p,w,r,i,s,i,f)),!0):!1}}n.DiffComputer=e;function o(N,m){const w=R.firstNonWhitespaceIndex(N);return w===-1?m:w+1}function h(N,m){const w=R.lastNonWhitespaceIndex(N);return w===-1?m:w+2}function b(N){if(N===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<N}}),$(j[30],G([0,1,25]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.ValidAnnotatedEditOperation=n.IndentGuideHorizontalLine=n.IndentGuide=n.HorizontalGuidesState=n.FindMatch=n.TextModelResolvedOptions=n.MinimapPosition=n.OverviewRulerLane=void 0;var R;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(R=n.OverviewRulerLane||(n.OverviewRulerLane={}));var E;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(E=n.MinimapPosition||(n.MinimapPosition={}));class a{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}n.TextModelResolvedOptions=a;class L{constructor(h,b){this._findMatchBrand=void 0,this.range=h,this.matches=b}}n.FindMatch=L;var v;(function(o){o[o.Disabled=0]="Disabled",o[o.EnabledForActive=1]="EnabledForActive",o[o.Enabled=2]="Enabled"})(v=n.HorizontalGuidesState||(n.HorizontalGuidesState={}));class u{constructor(h,b,N){this.visibleColumn=h,this.className=b,this.horizontalLine=N}}n.IndentGuide=u;class g{constructor(h,b){this.top=h,this.endColumn=b}}n.IndentGuideHorizontalLine=g;class C{constructor(h,b,N,m,w,p){this.identifier=h,this.range=b,this.text=N,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=w,this._isTracked=p}}n.ValidAnnotatedEditOperation=C;class e{constructor(h,b,N){this.reverseEdits=h,this.changes=b,this.trimAutoWhitespaceLineNumbers=N}}n.ApplyEditsResult=e}),$(j[31],G([0,1,3,26,4,5,30]),function(F,n,M,R,E,a,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.SearchData=n.isMultilineRegexSource=n.SearchParams=void 0;const v=999;class u{constructor(r,i,s,f){this.searchString=r,this.isRegex=i,this.matchCase=s,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=g(this.searchString):r=this.searchString.indexOf(`
`)>=0;let i=null;try{i=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch(f){return null}if(!i)return null;let s=!this.isRegex&&!r;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new C(i,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=u;function g(p){if(!p||p.length===0)return!1;for(let r=0,i=p.length;r<i;r++)if(p.charCodeAt(r)===92){if(r++,r>=i)break;const f=p.charCodeAt(r);if(f===110||f===114||f===87)return!0}return!1}n.isMultilineRegexSource=g;class C{constructor(r,i,s){this.regex=r,this.wordSeparators=i,this.simpleSearch=s}}n.SearchData=C;function e(p,r,i){if(!i)return new L.FindMatch(p,null);let s=[];for(let f=0,d=r.length;f<d;f++)s[f]=r[f];return new L.FindMatch(p,s)}n.createFindMatch=e;class o{constructor(r){let i=[],s=0;for(let f=0,d=r.length;f<d;f++)r.charCodeAt(f)===10&&(i[s++]=f);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(r){const i=this._lineFeedsOffsets;let s=0,f=i.length-1;if(f===-1||r<=i[0])return 0;for(;s<f;){const d=s+((f-s)/2>>0);i[d]>=r?f=d-1:i[d+1]>=r?(s=d,f=d):s=d+1}return s+1}}class h{static findMatches(r,i,s,f,d){const l=i.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(r,s,new w(l.wordSeparators,l.regex),f,d):this._doFindMatchesLineByLine(r,s,l,f,d):[]}static _getMultilineMatchRange(r,i,s,f,d,l){let _,c=0;f?(c=f.findLineFeedCountBeforeOffset(d),_=i+d+c):_=i+d;let S;if(f){let k=f.findLineFeedCountBeforeOffset(d+l.length)-c;S=_+l.length+k}else S=_+l.length;const A=r.getPositionAt(_),y=r.getPositionAt(S);return new a.Range(A.lineNumber,A.column,y.lineNumber,y.column)}static _doFindMatchesMultiline(r,i,s,f,d){const l=r.getOffsetAt(i.getStartPosition()),_=r.getValueInRange(i,1),c=r.getEOL()===`\r
`?new o(_):null,S=[];let A=0,y;for(s.reset(0);y=s.next(_);)if(S[A++]=e(this._getMultilineMatchRange(r,l,_,c,y.index,y[0]),y,f),A>=d)return S;return S}static _doFindMatchesLineByLine(r,i,s,f,d){const l=[];let _=0;if(i.startLineNumber===i.endLineNumber){const S=r.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return _=this._findMatchesInLine(s,S,i.startLineNumber,i.startColumn-1,_,l,f,d),l}const c=r.getLineContent(i.startLineNumber).substring(i.startColumn-1);_=this._findMatchesInLine(s,c,i.startLineNumber,i.startColumn-1,_,l,f,d);for(let S=i.startLineNumber+1;S<i.endLineNumber&&_<d;S++)_=this._findMatchesInLine(s,r.getLineContent(S),S,0,_,l,f,d);if(_<d){const S=r.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);_=this._findMatchesInLine(s,S,i.endLineNumber,0,_,l,f,d)}return l}static _findMatchesInLine(r,i,s,f,d,l,_,c){const S=r.wordSeparators;if(!_&&r.simpleSearch){const P=r.simpleSearch,k=P.length,O=i.length;let U=-k;for(;(U=i.indexOf(P,U+k))!==-1;)if((!S||m(S,i,O,U,k))&&(l[d++]=new L.FindMatch(new a.Range(s,U+1+f,s,U+1+k+f),null),d>=c))return d;return d}const A=new w(r.wordSeparators,r.regex);let y;A.reset(0);do if(y=A.next(i),y&&(l[d++]=e(new a.Range(s,y.index+1+f,s,y.index+1+y[0].length+f),y,_),d>=c))return d;while(y);return d}static findNextMatch(r,i,s,f){const d=i.parseSearchRequest();if(!d)return null;const l=new w(d.wordSeparators,d.regex);return d.regex.multiline?this._doFindNextMatchMultiline(r,s,l,f):this._doFindNextMatchLineByLine(r,s,l,f)}static _doFindNextMatchMultiline(r,i,s,f){const d=new E.Position(i.lineNumber,1),l=r.getOffsetAt(d),_=r.getLineCount(),c=r.getValueInRange(new a.Range(d.lineNumber,d.column,_,r.getLineMaxColumn(_)),1),S=r.getEOL()===`\r
`?new o(c):null;s.reset(i.column-1);let A=s.next(c);return A?e(this._getMultilineMatchRange(r,l,c,S,A.index,A[0]),A,f):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(r,new E.Position(1,1),s,f):null}static _doFindNextMatchLineByLine(r,i,s,f){const d=r.getLineCount(),l=i.lineNumber,_=r.getLineContent(l),c=this._findFirstMatchInLine(s,_,l,i.column,f);if(c)return c;for(let S=1;S<=d;S++){const A=(l+S-1)%d,y=r.getLineContent(A+1),P=this._findFirstMatchInLine(s,y,A+1,1,f);if(P)return P}return null}static _findFirstMatchInLine(r,i,s,f,d){r.reset(f-1);const l=r.next(i);return l?e(new a.Range(s,l.index+1,s,l.index+1+l[0].length),l,d):null}static findPreviousMatch(r,i,s,f){const d=i.parseSearchRequest();if(!d)return null;const l=new w(d.wordSeparators,d.regex);return d.regex.multiline?this._doFindPreviousMatchMultiline(r,s,l,f):this._doFindPreviousMatchLineByLine(r,s,l,f)}static _doFindPreviousMatchMultiline(r,i,s,f){const d=this._doFindMatchesMultiline(r,new a.Range(1,1,i.lineNumber,i.column),s,f,10*v);if(d.length>0)return d[d.length-1];const l=r.getLineCount();return i.lineNumber!==l||i.column!==r.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(r,new E.Position(l,r.getLineMaxColumn(l)),s,f):null}static _doFindPreviousMatchLineByLine(r,i,s,f){const d=r.getLineCount(),l=i.lineNumber,_=r.getLineContent(l).substring(0,i.column-1),c=this._findLastMatchInLine(s,_,l,f);if(c)return c;for(let S=1;S<=d;S++){const A=(d+l-S-1)%d,y=r.getLineContent(A+1),P=this._findLastMatchInLine(s,y,A+1,f);if(P)return P}return null}static _findLastMatchInLine(r,i,s,f){let d=null,l;for(r.reset(0);l=r.next(i);)d=e(new a.Range(s,l.index+1,s,l.index+1+l[0].length),l,f);return d}}n.TextModelSearch=h;function b(p,r,i,s,f){if(s===0)return!0;const d=r.charCodeAt(s-1);if(p.get(d)!==0||d===13||d===10)return!0;if(f>0){const l=r.charCodeAt(s);if(p.get(l)!==0)return!0}return!1}function N(p,r,i,s,f){if(s+f===i)return!0;const d=r.charCodeAt(s+f);if(p.get(d)!==0||d===13||d===10)return!0;if(f>0){const l=r.charCodeAt(s+f-1);if(p.get(l)!==0)return!0}return!1}function m(p,r,i,s,f){return b(p,r,i,s,f)&&N(p,r,i,s,f)}n.isValidMatch=m;class w{constructor(r,i){this._wordSeparators=r,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(r){this._searchRegex.lastIndex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(r){const i=r.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(r),!s))return null;const f=s.index,d=s[0].length;if(f===this._prevMatchStartIndex&&d===this._prevMatchLength){if(d===0){M.getNextCodePoint(r,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=f,this._prevMatchLength=d,!this._wordSeparators||m(this._wordSeparators,r,i,f,d))return s}while(s);return null}}n.Searcher=w}),$(j[32],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(v=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const g of n.USUAL_WORD_SEPARATORS)v.indexOf(g)>=0||(u+="\\"+g);return u+="\\s]+)",new RegExp(u,"g")}n.DEFAULT_WORD_REGEXP=M();function R(v){let u=n.DEFAULT_WORD_REGEXP;if(v&&v instanceof RegExp)if(v.global)u=v;else{let g="g";v.ignoreCase&&(g+="i"),v.multiline&&(g+="m"),v.unicode&&(g+="u"),u=new RegExp(v.source,g)}return u.lastIndex=0,u}n.ensureValidWordDefinition=R;const E={maxLen:1e3,windowSize:15,timeBudget:150};function a(v,u,g,C,e=E){if(g.length>e.maxLen){let m=v-e.maxLen/2;return m<0?m=0:C+=m,g=g.substring(m,v+e.maxLen/2),a(v,u,g,C,e)}const o=Date.now(),h=v-1-C;let b=-1,N=null;for(let m=1;!(Date.now()-o>=e.timeBudget);m++){const w=h-e.windowSize*m;u.lastIndex=Math.max(0,w);const p=L(u,g,h,b);if(!p&&N||(N=p,w<=0))break;b=w}if(N){let m={word:N[0],startColumn:C+1+N.index,endColumn:C+1+N.index+N[0].length};return u.lastIndex=0,m}return null}n.getWordAtText=a;function L(v,u,g,C){let e;for(;e=v.exec(u);){const o=e.index||0;if(o<=g&&v.lastIndex>=g)return e;if(C>0&&o>C)return null}return null}}),$(j[33],G([0,1,14]),function(F,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=void 0;class R{constructor(o,h,b){const N=new Uint8Array(o*h);for(let m=0,w=o*h;m<w;m++)N[m]=b;this._data=N,this.rows=o,this.cols=h}get(o,h){return this._data[o*this.cols+h]}set(o,h,b){this._data[o*this.cols+h]=b}}n.Uint8Matrix=R;class E{constructor(o){let h=0,b=0;for(let m=0,w=o.length;m<w;m++){let[p,r,i]=o[m];r>h&&(h=r),p>b&&(b=p),i>b&&(b=i)}h++,b++;let N=new R(b,h,0);for(let m=0,w=o.length;m<w;m++){let[p,r,i]=o[m];N.set(p,r,i)}this._states=N,this._maxCharCode=h}nextState(o,h){return h<0||h>=this._maxCharCode?0:this._states.get(o,h)}}n.StateMachine=E;let a=null;function L(){return a===null&&(a=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),a}let v=null;function u(){if(v===null){v=new M.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)v.set(e.charCodeAt(h),1);const o=".,;";for(let h=0;h<o.length;h++)v.set(o.charCodeAt(h),2)}return v}class g{static _createLink(o,h,b,N,m){let w=m-1;do{const p=h.charCodeAt(w);if(o.get(p)!==2)break;w--}while(w>N);if(N>0){const p=h.charCodeAt(N-1),r=h.charCodeAt(w);(p===40&&r===41||p===91&&r===93||p===123&&r===125)&&w--}return{range:{startLineNumber:b,startColumn:N+1,endLineNumber:b,endColumn:w+2},url:h.substring(N,w+1)}}static computeLinks(o,h=L()){const b=u();let N=[];for(let m=1,w=o.getLineCount();m<=w;m++){const p=o.getLineContent(m),r=p.length;let i=0,s=0,f=0,d=1,l=!1,_=!1,c=!1,S=!1;for(;i<r;){let A=!1;const y=p.charCodeAt(i);if(d===13){let P;switch(y){case 40:l=!0,P=0;break;case 41:P=l?0:1;break;case 91:c=!0,_=!0,P=0;break;case 93:c=!1,P=_?0:1;break;case 123:S=!0,P=0;break;case 125:P=S?0:1;break;case 39:P=f===34||f===96?0:1;break;case 34:P=f===39||f===96?0:1;break;case 96:P=f===39||f===34?0:1;break;case 42:P=f===42?1:0;break;case 124:P=f===124?1:0;break;case 32:P=c?0:1;break;default:P=b.get(y)}P===1&&(N.push(g._createLink(b,p,m,s,i)),A=!0)}else if(d===12){let P;y===91?(_=!0,P=0):P=b.get(y),P===1?A=!0:d=13}else d=h.nextState(d,y),d===0&&(A=!0);A&&(d=1,l=!1,_=!1,S=!1,s=i+1,f=y),i++}d===13&&N.push(g._createLink(b,p,m,s,r))}return N}}n.LinkComputer=g;function C(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:g.computeLinks(e)}n.computeLinks=C}),$(j[34],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(E,a,L,v,u){if(E&&a){let g=this.doNavigateValueSet(a,u);if(g)return{range:E,value:g}}if(L&&v){let g=this.doNavigateValueSet(v,u);if(g)return{range:L,value:g}}return null}doNavigateValueSet(E,a){let L=this.numberReplace(E,a);return L!==null?L:this.textReplace(E,a)}numberReplace(E,a){let L=Math.pow(10,E.length-(E.lastIndexOf(".")+1)),v=Number(E),u=parseFloat(E);return!isNaN(v)&&!isNaN(u)&&v===u?v===0&&!a?null:(v=Math.floor(v*L),v+=a?L:-L,String(v/L)):null}textReplace(E,a){return this.valueSetsReplace(this._defaultValueSet,E,a)}valueSetsReplace(E,a,L){let v=null;for(let u=0,g=E.length;v===null&&u<g;u++)v=this.valueSetReplace(E[u],a,L);return v}valueSetReplace(E,a,L){let v=E.indexOf(a);return v>=0?(v+=L?1:-1,v<0?v=E.length-1:v%=E.length,E[v]):null}}n.BasicInplaceReplace=M,M.INSTANCE=new M}),$(j[35],G([0,1,5,31,3,6]),function(F,n,M,R,E,a){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class L{static computeUnicodeHighlights(C,e,o){const h=o?o.startLineNumber:1,b=o?o.endLineNumber:C.getLineCount(),N=new u(e),m=N.getCandidateCodePoints();let w;m==="allNonBasicAscii"?w=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):w=new RegExp(`${v(Array.from(m))}`,"g");const p=new R.Searcher(null,w),r=[];let i=!1,s,f=0,d=0,l=0;e:for(let _=h,c=b;_<=c;_++){const S=C.getLineContent(_),A=S.length;p.reset(0);do if(s=p.next(S),s){let y=s.index,P=s.index+s[0].length;if(y>0){const U=S.charCodeAt(y-1);E.isHighSurrogate(U)&&y--}if(P+1<A){const U=S.charCodeAt(P-1);E.isHighSurrogate(U)&&P++}const k=S.substring(y,P),O=N.shouldHighlightNonBasicASCII(k);if(O!==0){O===3?f++:O===2?d++:O===1?l++:(0,a.assertNever)(O);const U=1e3;if(r.length>=U){i=!0;break e}r.push(new M.Range(_,y+1,_,P+1))}}while(s)}return{ranges:r,hasMore:i,ambiguousCharacterCount:f,invisibleCharacterCount:d,nonBasicAsciiCharacterCount:l}}static computeUnicodeHighlightReason(C,e){switch(new u(e).shouldHighlightNonBasicASCII(C)){case 0:return null;case 2:return{kind:1};case 3:const b=E.AmbiguousCharacters.getPrimaryConfusable(C.codePointAt(0));return{kind:0,confusableWith:String.fromCodePoint(b)};case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=L;function v(g,C){return`[${E.escapeRegExpCharacters(g.map(o=>String.fromCodePoint(o)).join(""))}]`}class u{constructor(C){this.options=C,this.allowedCodePoints=new Set(C.allowedCodePoints)}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const C=new Set;if(this.options.invisibleCharacters)for(const e of E.InvisibleCharacters.codePoints)C.add(e);if(this.options.ambiguousCharacters)for(const e of E.AmbiguousCharacters.getPrimaryConfusableCodePoints())C.add(e);for(const e of this.allowedCodePoints)C.delete(e);return C}shouldHighlightNonBasicASCII(C){const e=C.codePointAt(0);return this.allowedCodePoints.has(e)?0:this.options.nonBasicASCII?1:this.options.invisibleCharacters&&!(C===" "||C===`
`||C==="	")&&E.InvisibleCharacters.isInvisibleCharacter(e)?2:this.options.ambiguousCharacters&&E.AmbiguousCharacters.isAmbiguous(e)?3:0}}}),$(j[36],G([0,1]),function(F,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var M;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(M=n.AccessibilitySupport||(n.AccessibilitySupport={}));var R;(function(t){t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(R=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var E;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(E=n.CompletionItemKind||(n.CompletionItemKind={}));var a;(function(t){t[t.Deprecated=1]="Deprecated"})(a=n.CompletionItemTag||(n.CompletionItemTag={}));var L;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var v;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(v=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var u;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(u=n.CursorChangeReason||(n.CursorChangeReason={}));var g;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(g=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var C;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(C=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var e;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(e=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var o;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.columnSelection=18]="columnSelection",t[t.comments=19]="comments",t[t.contextmenu=20]="contextmenu",t[t.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",t[t.cursorBlinking=22]="cursorBlinking",t[t.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",t[t.cursorStyle=24]="cursorStyle",t[t.cursorSurroundingLines=25]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",t[t.cursorWidth=27]="cursorWidth",t[t.disableLayerHinting=28]="disableLayerHinting",t[t.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",t[t.domReadOnly=30]="domReadOnly",t[t.dragAndDrop=31]="dragAndDrop",t[t.emptySelectionClipboard=32]="emptySelectionClipboard",t[t.extraEditorClassName=33]="extraEditorClassName",t[t.fastScrollSensitivity=34]="fastScrollSensitivity",t[t.find=35]="find",t[t.fixedOverflowWidgets=36]="fixedOverflowWidgets",t[t.folding=37]="folding",t[t.foldingStrategy=38]="foldingStrategy",t[t.foldingHighlight=39]="foldingHighlight",t[t.foldingImportsByDefault=40]="foldingImportsByDefault",t[t.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=42]="fontFamily",t[t.fontInfo=43]="fontInfo",t[t.fontLigatures=44]="fontLigatures",t[t.fontSize=45]="fontSize",t[t.fontWeight=46]="fontWeight",t[t.formatOnPaste=47]="formatOnPaste",t[t.formatOnType=48]="formatOnType",t[t.glyphMargin=49]="glyphMargin",t[t.gotoLocation=50]="gotoLocation",t[t.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",t[t.hover=52]="hover",t[t.inDiffEditor=53]="inDiffEditor",t[t.inlineSuggest=54]="inlineSuggest",t[t.letterSpacing=55]="letterSpacing",t[t.lightbulb=56]="lightbulb",t[t.lineDecorationsWidth=57]="lineDecorationsWidth",t[t.lineHeight=58]="lineHeight",t[t.lineNumbers=59]="lineNumbers",t[t.lineNumbersMinChars=60]="lineNumbersMinChars",t[t.linkedEditing=61]="linkedEditing",t[t.links=62]="links",t[t.matchBrackets=63]="matchBrackets",t[t.minimap=64]="minimap",t[t.mouseStyle=65]="mouseStyle",t[t.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=67]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",t[t.multiCursorModifier=69]="multiCursorModifier",t[t.multiCursorPaste=70]="multiCursorPaste",t[t.occurrencesHighlight=71]="occurrencesHighlight",t[t.overviewRulerBorder=72]="overviewRulerBorder",t[t.overviewRulerLanes=73]="overviewRulerLanes",t[t.padding=74]="padding",t[t.parameterHints=75]="parameterHints",t[t.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",t[t.quickSuggestions=78]="quickSuggestions",t[t.quickSuggestionsDelay=79]="quickSuggestionsDelay",t[t.readOnly=80]="readOnly",t[t.renameOnType=81]="renameOnType",t[t.renderControlCharacters=82]="renderControlCharacters",t[t.renderFinalNewline=83]="renderFinalNewline",t[t.renderLineHighlight=84]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=86]="renderValidationDecorations",t[t.renderWhitespace=87]="renderWhitespace",t[t.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",t[t.roundedSelection=89]="roundedSelection",t[t.rulers=90]="rulers",t[t.scrollbar=91]="scrollbar",t[t.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=93]="scrollBeyondLastLine",t[t.scrollPredominantAxis=94]="scrollPredominantAxis",t[t.selectionClipboard=95]="selectionClipboard",t[t.selectionHighlight=96]="selectionHighlight",t[t.selectOnLineNumbers=97]="selectOnLineNumbers",t[t.showFoldingControls=98]="showFoldingControls",t[t.showUnused=99]="showUnused",t[t.snippetSuggestions=100]="snippetSuggestions",t[t.smartSelect=101]="smartSelect",t[t.smoothScrolling=102]="smoothScrolling",t[t.stickyTabStops=103]="stickyTabStops",t[t.stopRenderingLineAfter=104]="stopRenderingLineAfter",t[t.suggest=105]="suggest",t[t.suggestFontSize=106]="suggestFontSize",t[t.suggestLineHeight=107]="suggestLineHeight",t[t.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",t[t.suggestSelection=109]="suggestSelection",t[t.tabCompletion=110]="tabCompletion",t[t.tabIndex=111]="tabIndex",t[t.unicodeHighlighting=112]="unicodeHighlighting",t[t.unusualLineTerminators=113]="unusualLineTerminators",t[t.useShadowDOM=114]="useShadowDOM",t[t.useTabStops=115]="useTabStops",t[t.wordSeparators=116]="wordSeparators",t[t.wordWrap=117]="wordWrap",t[t.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=120]="wordWrapColumn",t[t.wordWrapOverride1=121]="wordWrapOverride1",t[t.wordWrapOverride2=122]="wordWrapOverride2",t[t.wrappingIndent=123]="wrappingIndent",t[t.wrappingStrategy=124]="wrappingStrategy",t[t.showDeprecated=125]="showDeprecated",t[t.inlayHints=126]="inlayHints",t[t.editorClassName=127]="editorClassName",t[t.pixelRatio=128]="pixelRatio",t[t.tabFocusMode=129]="tabFocusMode",t[t.layoutInfo=130]="layoutInfo",t[t.wrappingInfo=131]="wrappingInfo"})(o=n.EditorOption||(n.EditorOption={}));var h;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(h=n.EndOfLinePreference||(n.EndOfLinePreference={}));var b;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(b=n.EndOfLineSequence||(n.EndOfLineSequence={}));var N;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(N=n.IndentAction||(n.IndentAction={}));var m;(function(t){t[t.Other=0]="Other",t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=n.InlayHintKind||(n.InlayHintKind={}));var w;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(w=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=n.KeyCode||(n.KeyCode={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r=n.MarkerSeverity||(n.MarkerSeverity={}));var i;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(i=n.MarkerTag||(n.MarkerTag={}));var s;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(s=n.MinimapPosition||(n.MinimapPosition={}));var f;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f=n.MouseTargetType||(n.MouseTargetType={}));var d;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(d=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var l;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(l=n.OverviewRulerLane||(n.OverviewRulerLane={}));var _;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(_=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var c;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(c=n.RenderMinimap||(n.RenderMinimap={}));var S;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(S=n.ScrollType||(n.ScrollType={}));var A;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(A=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var y;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(y=n.SelectionDirection||(n.SelectionDirection={}));var P;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(P=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var k;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(k=n.SymbolKind||(n.SymbolKind={}));var O;(function(t){t[t.Deprecated=1]="Deprecated"})(O=n.SymbolTag||(n.SymbolTag={}));var U;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(U=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var T;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(T=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var H;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(H=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var W;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(W=n.WrappingIndent||(n.WrappingIndent={}))}),$(j[37],G([0,1,23,7,19,13,4,5,27,28,36]),function(F,n,M,R,E,a,L,v,u,g,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(b,N){return(0,E.KeyChord)(b,N)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function o(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:R.Emitter,KeyCode:C.KeyCode,KeyMod:e,Position:L.Position,Range:v.Range,Selection:u.Selection,SelectionDirection:C.SelectionDirection,MarkerSeverity:C.MarkerSeverity,MarkerTag:C.MarkerTag,Uri:a.URI,Token:g.Token}}n.createMonacoBaseAPI=o}),$(j[38],G([0,1,15,12]),function(F,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class E{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(u,g){u=(0,R.toUint32)(u);const C=this.values,e=this.prefixSum,o=g.length;return o===0?!1:(this.values=new Uint32Array(C.length+o),this.values.set(C.subarray(0,u),0),this.values.set(C.subarray(u),u+o),this.values.set(g,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,g){return u=(0,R.toUint32)(u),g=(0,R.toUint32)(g),this.values[u]===g?!1:(this.values[u]=g,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,g){u=(0,R.toUint32)(u),g=(0,R.toUint32)(g);const C=this.values,e=this.prefixSum;if(u>=C.length)return!1;let o=C.length-u;return g>=o&&(g=o),g===0?!1:(this.values=new Uint32Array(C.length-g),this.values.set(C.subarray(0,u),0),this.values.set(C.subarray(u+g),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,R.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let g=this.prefixSumValidIndex[0]+1;g===0&&(this.prefixSum[0]=this.values[0],g++),u>=this.values.length&&(u=this.values.length-1);for(let C=g;C<=u;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let g=0,C=this.values.length-1,e=0,o=0,h=0;for(;g<=C;)if(e=g+(C-g)/2|0,o=this.prefixSum[e],h=o-this.values[e],u<h)C=e-1;else if(u>=o)g=e+1;else break;return new L(e,u-h)}}n.PrefixSumComputer=E;class a{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const g=this._indexBySum[u],C=g>0?this._prefixSum[g-1]:0;return new L(g,u-C)}removeValues(u,g){this._values.splice(u,g),this._invalidate(u)}insertValues(u,g){this._values=(0,M.arrayInsert)(this._values,u,g),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,g=this._values.length;u<g;u++){const C=this._values[u],e=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=e+C;for(let o=0;o<C;o++)this._indexBySum[e+o]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,g){this._values[u]!==g&&(this._values[u]=g,this._invalidate(u))}}n.ConstantTimePrefixSumComputer=a;class L{constructor(u,g){this.index=u,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=g}}n.PrefixSumIndexOfResult=L}),$(j[39],G([0,1,3,4,38]),function(F,n,M,R,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class a{constructor(v,u,g,C){this._uri=v,this._lines=u,this._eol=g,this._versionId=C,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const u=v.changes;for(const g of u)this._acceptDeleteRange(g.range),this._acceptInsertText(new R.Position(g.range.startLineNumber,g.range.startColumn),g.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,u=this._lines.length,g=new Uint32Array(u);for(let C=0;C<u;C++)g[C]=this._lines[C].length+v;this._lineStarts=new E.PrefixSumComputer(g)}}_setLineText(v,u){this._lines[v]=u,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,u){if(u.length===0)return;let g=(0,M.splitLines)(u);if(g.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+g[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}g[g.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+g[0]);let C=new Uint32Array(g.length-1);for(let e=1;e<g.length;e++)this._lines.splice(v.lineNumber+e-1,0,g[e]),C[e-1]=g[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,C)}}n.MirrorTextModel=a});var ie=this&&this.__awaiter||function(F,n,M,R){function E(a){return a instanceof M?a:new M(function(L){L(a)})}return new(M||(M=Promise))(function(a,L){function v(C){try{g(R.next(C))}catch(e){L(e)}}function u(C){try{g(R.throw(C))}catch(e){L(e)}}function g(C){C.done?a(C.value):E(C.value).then(v,u)}g((R=R.apply(F,n||[])).next())})};$(j[41],G([0,1,11,2,13,4,5,29,39,32,33,34,37,6,10,35]),function(F,n,M,R,E,a,L,v,u,g,C,e,o,h,b,N){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class m extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,s){let f=(0,g.getWordAtText)(i.column,(0,g.ensureValidWordDefinition)(s),this._lines[i.lineNumber-1],0);return f?new L.Range(i.lineNumber,f.startColumn,i.lineNumber,f.endColumn):null}words(i){const s=this._lines,f=this._wordenize.bind(this);let d=0,l="",_=0,c=[];return{*[Symbol.iterator](){for(;;)if(_<c.length){const S=l.substring(c[_].start,c[_].end);_+=1,yield S}else if(d<s.length)l=s[d],c=f(l,i),_=0,d+=1;else break}}}getLineWords(i,s){let f=this._lines[i-1],d=this._wordenize(f,s),l=[];for(const _ of d)l.push({word:f.substring(_.start,_.end),startColumn:_.start+1,endColumn:_.end+1});return l}_wordenize(i,s){const f=[];let d;for(s.lastIndex=0;(d=s.exec(i))&&d[0].length!==0;)f.push({start:d.index,end:d.index+d[0].length});return f}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let s=this._eol,f=i.startLineNumber-1,d=i.endLineNumber-1,l=[];l.push(this._lines[f].substring(i.startColumn-1));for(let _=f+1;_<d;_++)l.push(this._lines[_]);return l.push(this._lines[d].substring(0,i.endColumn-1)),l.join(s)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let s=this._lineStarts.getIndexOf(i),f=this._lines[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,f)}}_validateRange(i){const s=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),f=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return s.lineNumber!==i.startLineNumber||s.column!==i.startColumn||f.lineNumber!==i.endLineNumber||f.column!==i.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:f.lineNumber,endColumn:f.column}:i}_validatePosition(i){if(!a.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:s,column:f}=i,d=!1;if(s<1)s=1,f=1,d=!0;else if(s>this._lines.length)s=this._lines.length,f=this._lines[s-1].length+1,d=!0;else{let l=this._lines[s-1].length+1;f<1?(f=1,d=!0):f>l&&(f=l,d=!0)}return d?{lineNumber:s,column:f}:i}}n.MirrorModel=m;class w{constructor(i,s){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=s,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(s=>i.push(this._models[s])),i}acceptNewModel(i){this._models[i.url]=new m(E.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,s){if(!this._models[i])return;this._models[i].onEvents(s)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}computeUnicodeHighlights(i,s,f){return ie(this,void 0,void 0,function*(){const d=this._getModel(i);return d?N.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,s,f):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(i,s,f,d){return ie(this,void 0,void 0,function*(){const l=this._getModel(i),_=this._getModel(s);if(!l||!_)return null;const c=l.getLinesContent(),S=_.getLinesContent(),y=new v.DiffComputer(c,S,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:d}).computeDiff(),P=y.changes.length>0?!1:this._modelsAreIdentical(l,_);return{quitEarly:y.quitEarly,identical:P,changes:y.changes}})}_modelsAreIdentical(i,s){const f=i.getLineCount(),d=s.getLineCount();if(f!==d)return!1;for(let l=1;l<=f;l++){const _=i.getLineContent(l),c=s.getLineContent(l);if(_!==c)return!1}return!0}computeMoreMinimalEdits(i,s){return ie(this,void 0,void 0,function*(){const f=this._getModel(i);if(!f)return s;const d=[];let l;s=s.slice(0).sort((_,c)=>{if(_.range&&c.range)return L.Range.compareRangesUsingStarts(_.range,c.range);let S=_.range?0:1,A=c.range?0:1;return S-A});for(let{range:_,text:c,eol:S}of s){if(typeof S=="number"&&(l=S),L.Range.isEmpty(_)&&!c)continue;const A=f.getValueInRange(_);if(c=c.replace(/\r\n|\n|\r/g,f.eol),A===c)continue;if(Math.max(c.length,A.length)>w._diffLimit){d.push({range:_,text:c});continue}const y=(0,M.stringDiff)(A,c,!1),P=f.offsetAt(L.Range.lift(_).getStartPosition());for(const k of y){const O=f.positionAt(P+k.originalStart),U=f.positionAt(P+k.originalStart+k.originalLength),T={text:c.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:O.lineNumber,startColumn:O.column,endLineNumber:U.lineNumber,endColumn:U.column}};f.getValueInRange(T.range)!==T.text&&d.push(T)}}return typeof l=="number"&&d.push({eol:l,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d})}computeLinks(i){return ie(this,void 0,void 0,function*(){let s=this._getModel(i);return s?(0,C.computeLinks)(s):null})}textualSuggest(i,s,f,d){return ie(this,void 0,void 0,function*(){const l=new b.StopWatch(!0),_=new RegExp(f,d),c=new Set;e:for(let S of i){const A=this._getModel(S);if(!!A){for(let y of A.words(_))if(!(y===s||!isNaN(Number(y)))&&(c.add(y),c.size>w._suggestionsLimit))break e}}return{words:Array.from(c),duration:l.elapsed()}})}computeWordRanges(i,s,f,d){return ie(this,void 0,void 0,function*(){let l=this._getModel(i);if(!l)return Object.create(null);const _=new RegExp(f,d),c=Object.create(null);for(let S=s.startLineNumber;S<s.endLineNumber;S++){let A=l.getLineWords(S,_);for(const y of A){if(!isNaN(Number(y.word)))continue;let P=c[y.word];P||(P=[],c[y.word]=P),P.push({startLineNumber:S,startColumn:y.startColumn,endLineNumber:S,endColumn:y.endColumn})}}return c})}navigateValueSet(i,s,f,d,l){return ie(this,void 0,void 0,function*(){let _=this._getModel(i);if(!_)return null;let c=new RegExp(d,l);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});let S=_.getValueInRange(s),A=_.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},c);if(!A)return null;let y=_.getValueInRange(A);return e.BasicInplaceReplace.INSTANCE.navigateValueSet(s,S,A,y,f)})}loadForeignModule(i,s,f){const d=(c,S)=>this._host.fhr(c,S);let _={host:h.createProxyObject(f,d),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(_,s),Promise.resolve(h.getAllMethodNames(this._foreignModule))):new Promise((c,S)=>{F([i],A=>{this._foreignModule=A.create(_,s),c(h.getAllMethodNames(this._foreignModule))},S)})}fmr(i,s){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,s))}catch(f){return Promise.reject(f)}}}n.EditorSimpleWorker=w,w._diffLimit=1e5,w._suggestionsLimit=1e4;function p(r){return new w(r,null)}n.create=p,typeof importScripts=="function"&&(R.globals.monaco=(0,o.createMonacoBaseAPI)())}),function(){var F,n;const M=self.MonacoEnvironment,R=M&&M.baseUrl?M.baseUrl:"../../../",E=typeof((F=self.trustedTypes)===null||F===void 0?void 0:F.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:C=>C,createScript:(C,...e)=>{const o=e.slice(0,-1).join(","),h=e.pop().toString();return`(function anonymous(${o}) {
${h}
})`}}):void 0;function a(){try{return(E?self.eval(E.createScript("","true")):new Function("true")).call(self),!0}catch(C){return!1}}function L(){return new Promise((C,e)=>{if(typeof self.define=="function"&&self.define.amd)return C();const o=R+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&a()){fetch(o).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${o}`,(E?self.eval(E.createScript("",b)):new Function(b)).call(self),C()}).then(void 0,e);return}E?importScripts(E.createScriptURL(o)):importScripts(o),C()})}const v=function(C){L().then(()=>{require.config({baseUrl:R,catchError:!0,trustedTypesPolicy:E,amdModulesPattern:/^vs\//}),require([C],function(e){setTimeout(function(){let o=e.create((h,b)=>{self.postMessage(h,b)},null);for(self.onmessage=h=>o.onmessage(h.data,h.ports);g.length>0;)self.onmessage(g.shift())},0)})})};let u=!0,g=[];self.onmessage=C=>{if(!u){g.push(C);return}u=!1,v(C.data)}}()}).call(this);

//# sourceMappingURL=./thirds/monaco-editor/min-maps/vs/base/worker/workerMain.js.map